(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 12.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     44496,       1238]
NotebookOptionsPosition[     39938,       1155]
NotebookOutlinePosition[     40340,       1171]
CellTagsIndexPosition[     40297,       1168]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[{
 RowBox[{
  RowBox[{"u", "[", "q_", "]"}], ":=", 
  FractionBox[
   RowBox[{
    SuperscriptBox["q", "2"], 
    SuperscriptBox["b", "2"]}], "2"]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Fi", "[", "q_", "]"}], ":=", 
  RowBox[{
   SuperscriptBox["E", 
    RowBox[{
     RowBox[{"-", 
      RowBox[{"u", "[", "q", "]"}]}], "/", "2"}]], " ", "ci", " ", 
   SuperscriptBox[
    RowBox[{"u", "[", "q", "]"}], "i"]}]}]}], "Input",
 CellChangeTimes->{{3.945853851501953*^9, 3.945853875104348*^9}, {
  3.945853942365032*^9, 3.9458540142978873`*^9}, {3.945854218731786*^9, 
  3.945854218920044*^9}},
 CellLabel->"In[1]:=",ExpressionUUID->"ae97deab-f6c3-4f19-84d1-0d46bb11c510"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Fi", "[", "q", "]"}]], "Input",
 CellChangeTimes->{{3.9458540223125257`*^9, 3.945854024411048*^9}},
 CellLabel->"In[3]:=",ExpressionUUID->"1d7d5949-cd8e-4a88-850f-58ab92e1ad42"],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["2", 
   RowBox[{"-", "i"}]], " ", "ci", " ", 
  SuperscriptBox["\[ExponentialE]", 
   RowBox[{
    RowBox[{"-", 
     FractionBox["1", "4"]}], " ", 
    SuperscriptBox["b", "2"], " ", 
    SuperscriptBox["q", "2"]}]], " ", 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{
     SuperscriptBox["b", "2"], " ", 
     SuperscriptBox["q", "2"]}], ")"}], "i"]}]], "Output",
 CellChangeTimes->{3.945929852227646*^9},
 CellLabel->"Out[3]=",ExpressionUUID->"c967390a-11eb-42c5-a185-c0b505a83842"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"devide", " ", "by", " ", "2", 
    RowBox[{"pi", "^", "2"}], " ", "in", " ", "the", " ", "end"}], " ", 
   "*)"}]}]], "Input",
 CellChangeTimes->{{3.945861464538362*^9, 3.9458614739322395`*^9}},
 CellLabel->"In[69]:=",ExpressionUUID->"a4243bd8-14a8-47a8-8da3-eb8000aa63f4"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"\[Rho]0", "[", "r_", "]"}], ":=", 
  RowBox[{"Integrate", "[", 
   RowBox[{
    RowBox[{
     SuperscriptBox["q", "2"], " ", 
     SuperscriptBox["q", "k"], " ", 
     RowBox[{"SphericalBesselJ", "[", 
      RowBox[{"0", ",", 
       RowBox[{"q", " ", "r"}]}], "]"}], " ", 
     RowBox[{"Fi", "[", "q", "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"q", ",", "0", ",", "Infinity"}], "}"}], ",", 
    RowBox[{"Assumptions", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"r", ">=", "0"}], ",", 
       RowBox[{"b", ">", "0"}], ",", 
       RowBox[{"i", ">=", "0"}], ",", 
       RowBox[{"k", ">=", "0"}]}], "}"}]}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Rho]L", "[", "r_", "]"}], ":=", 
  RowBox[{"Integrate", "[", 
   RowBox[{
    RowBox[{
     SuperscriptBox["q", "2"], " ", 
     SuperscriptBox["q", "k"], " ", 
     RowBox[{"SphericalBesselJ", "[", 
      RowBox[{"L", ",", 
       RowBox[{"q", " ", "r"}]}], "]"}], " ", 
     RowBox[{"Fi", "[", "q", "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"q", ",", "0", ",", "Infinity"}], "}"}], ",", 
    RowBox[{"Assumptions", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"L", ">=", "0"}], ",", 
       RowBox[{"r", ">=", "0"}], ",", 
       RowBox[{"b", ">", "0"}], ",", 
       RowBox[{"i", ">=", "0"}], ",", 
       RowBox[{"k", ">=", "0"}]}], "}"}]}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.9458540339268928`*^9, 3.945854133888459*^9}, {
  3.9458541774347005`*^9, 3.9458541961330357`*^9}, {3.9458542755803356`*^9, 
  3.9458542989241343`*^9}, {3.9458543395978365`*^9, 3.9458543606249485`*^9}, {
  3.9458613579084888`*^9, 3.9458613912330446`*^9}, {3.945861459063647*^9, 
  3.945861460311282*^9}},
 CellLabel->"In[4]:=",ExpressionUUID->"7f263f94-e539-4f81-b442-3ae70f478189"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[Rho]0", "[", "r", "]"}]], "Input",
 CellChangeTimes->{{3.945854137911683*^9, 3.945854139843301*^9}, 
   3.945854303225587*^9, {3.945854504479123*^9, 3.9458545337751637`*^9}},
 CellLabel->"In[6]:=",ExpressionUUID->"0693bd4a-912a-43fb-a9b8-a6e4f8e8af12"],

Cell[BoxData[
 TemplateBox[{
   RowBox[{
     SuperscriptBox["2", 
      RowBox[{"2", "+", "i", "+", "k"}]], " ", 
     SuperscriptBox["b", 
      RowBox[{
        RowBox[{"-", "3"}], "-", "k"}]], " ", "ci", " ", 
     RowBox[{"Gamma", "[", 
       RowBox[{
         FractionBox["3", "2"], "+", "i", "+", 
         FractionBox["k", "2"]}], "]"}], " ", 
     RowBox[{"Hypergeometric1F1", "[", 
       RowBox[{
         RowBox[{
           FractionBox["3", "2"], "+", "i", "+", 
           FractionBox["k", "2"]}], ",", 
         FractionBox["3", "2"], ",", 
         RowBox[{"-", 
           FractionBox[
            SuperscriptBox["r", "2"], 
            SuperscriptBox["b", "2"]]}]}], "]"}]}], 
   RowBox[{"r", ">", "0"}]},
  "ConditionalExpression"]], "Output",
 CellChangeTimes->{{3.9458542050961723`*^9, 3.9458542156792884`*^9}, {
   3.945854273412814*^9, 3.9458543038551846`*^9}, 3.9458543393313274`*^9, 
   3.945854369921075*^9, {3.945854512913486*^9, 3.9458545390858574`*^9}, 
   3.9458599902094903`*^9, 3.945860922875639*^9, 3.9458613985594893`*^9, 
   3.945861482669902*^9, 3.9459298596346827`*^9},
 CellLabel->"Out[6]=",ExpressionUUID->"70e7e1e5-52fe-4d6c-9343-37a56da4751c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[Rho]L", "[", "r", "]"}]], "Input",
 CellChangeTimes->{{3.9458543120762954`*^9, 3.9458543123603745`*^9}, {
  3.9458545120342145`*^9, 3.9458545297274094`*^9}},
 CellLabel->"In[7]:=",ExpressionUUID->"405675d5-9d1c-4c22-a5fc-0ebc9ffb95a4"],

Cell[BoxData[
 TemplateBox[{
   RowBox[{
     SuperscriptBox["2", 
      RowBox[{"1", "+", "i", "+", "k"}]], " ", 
     SuperscriptBox["b", 
      RowBox[{
        RowBox[{"-", "3"}], "-", "k", "-", "L"}]], " ", "ci", " ", 
     SqrtBox["\[Pi]"], " ", 
     SuperscriptBox["r", "L"], " ", 
     RowBox[{"Gamma", "[", 
       RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"(", 
           RowBox[{"3", "+", 
             RowBox[{"2", " ", "i"}], "+", "k", "+", "L"}], ")"}]}], "]"}], 
     " ", 
     RowBox[{"Hypergeometric1F1Regularized", "[", 
       RowBox[{
         RowBox[{
           FractionBox["1", "2"], " ", 
           RowBox[{"(", 
             RowBox[{"3", "+", 
               RowBox[{"2", " ", "i"}], "+", "k", "+", "L"}], ")"}]}], ",", 
         RowBox[{
           FractionBox["3", "2"], "+", "L"}], ",", 
         RowBox[{"-", 
           FractionBox[
            SuperscriptBox["r", "2"], 
            SuperscriptBox["b", "2"]]}]}], "]"}]}], 
   RowBox[{"r", ">", "0"}]},
  "ConditionalExpression"]], "Output",
 CellChangeTimes->{
  3.945854381936134*^9, {3.945854523509717*^9, 3.9458545470444794`*^9}, 
   3.945859997627124*^9, 3.9458609312713037`*^9, 3.9458614074636583`*^9, 
   3.945861491207958*^9, 3.945929866845739*^9},
 CellLabel->"Out[7]=",ExpressionUUID->"dfcf891c-6ec1-4778-97a5-27cc271641b8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"\[Rho]L", "[", "r", "]"}], "/.", 
  RowBox[{"{", 
   RowBox[{"L", "->", "0"}], "}"}]}]], "Input",
 CellChangeTimes->{{3.945859972150967*^9, 3.9458599756818733`*^9}},
 CellLabel->"In[8]:=",ExpressionUUID->"63708d27-17a5-41d1-a2e3-0fc19b3be1c2"],

Cell[BoxData[
 TemplateBox[{
   RowBox[{
     SuperscriptBox["2", 
      RowBox[{"2", "+", "i", "+", "k"}]], " ", 
     SuperscriptBox["b", 
      RowBox[{
        RowBox[{"-", "3"}], "-", "k"}]], " ", "ci", " ", 
     RowBox[{"Gamma", "[", 
       RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"(", 
           RowBox[{"3", "+", 
             RowBox[{"2", " ", "i"}], "+", "k"}], ")"}]}], "]"}], " ", 
     RowBox[{"HypergeometricPFQ", "[", 
       RowBox[{
         RowBox[{"{", 
           RowBox[{
             FractionBox["3", "2"], "+", "i", "+", 
             FractionBox["k", "2"]}], "}"}], ",", 
         RowBox[{"{", 
           FractionBox["3", "2"], "}"}], ",", 
         RowBox[{"-", 
           FractionBox[
            SuperscriptBox["r", "2"], 
            SuperscriptBox["b", "2"]]}]}], "]"}]}], 
   RowBox[{"r", ">", "0"}]},
  "ConditionalExpression"]], "Output",
 CellChangeTimes->{{3.945859976702132*^9, 3.9458600046439652`*^9}, 
   3.945860939390523*^9, 3.9458614160210066`*^9, {3.9458614999149885`*^9, 
   3.9458615082713966`*^9}, 3.945929873596344*^9},
 CellLabel->"Out[8]=",ExpressionUUID->"8c8e5f7e-21be-4741-93ba-927ed46761df"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"r", "^", "2"}], " ", 
    RowBox[{"\[Rho]0", "[", "r", "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"r", ",", "0", ",", "Infinity"}], "}"}], ",", 
   RowBox[{"Assumptions", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"b", ">", "0"}], ",", 
      RowBox[{"i", ">", "0"}], ",", 
      RowBox[{"k", ">=", "0"}]}], "}"}]}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"r", "^", "4"}], " ", 
    RowBox[{"\[Rho]0", "[", "r", "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"r", ",", "0", ",", "Infinity"}], "}"}], ",", 
   RowBox[{"Assumptions", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"b", ">", "0"}], ",", 
      RowBox[{"i", ">", "2"}], ",", 
      RowBox[{"k", ">=", "0"}]}], "}"}]}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.94592987869254*^9, 3.945929899411916*^9}, {
  3.9459299331223993`*^9, 3.945929933270049*^9}, {3.945930064404153*^9, 
  3.945930065091811*^9}, {3.9459301877488565`*^9, 3.9459301918605657`*^9}, {
  3.9459302714050984`*^9, 
  3.945930272987934*^9}},ExpressionUUID->"3eda0f84-e6f3-4f71-81fc-\
7abf27ad3b3c"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.945929988239337*^9, 3.945930067162428*^9, 
  3.9459301172069893`*^9, 3.945930204504116*^9},
 CellLabel->"Out[25]=",ExpressionUUID->"8ebbf4bb-63ce-447a-8cf1-5fcaf088d9cd"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.945929988239337*^9, 3.945930067162428*^9, 
  3.9459301172069893`*^9, 3.94593021189361*^9},
 CellLabel->"Out[26]=",ExpressionUUID->"9d243875-1d97-49d8-885d-ea7a4c1e783d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Integrate", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"r", "^", "2"}], " ", 
      RowBox[{"\[Rho]0", "[", "r", "]"}]}], "/.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"i", "->", "0"}], ",", 
       RowBox[{"k", "->", "0"}]}], "}"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"r", ",", "0", ",", "Infinity"}], "}"}], ",", 
    RowBox[{"Assumptions", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"b", ">", "0"}], "}"}]}]}], "]"}], "*", "4", 
  RowBox[{"Pi", "/", 
   RowBox[{"(", 
    RowBox[{"2", "*", 
     RowBox[{"Pi", "^", "2"}]}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.945930339926543*^9, 3.945930386970812*^9}, {
  3.945930422840165*^9, 3.9459304230327964`*^9}, {3.9459307118695097`*^9, 
  3.945930718920827*^9}},
 CellLabel->"In[46]:=",ExpressionUUID->"4898badd-2f85-4541-bce1-208f536cbd73"],

Cell[BoxData["ci"], "Output",
 CellChangeTimes->{{3.9459303643552036`*^9, 3.9459303763936377`*^9}, {
   3.9459304098074183`*^9, 3.9459304280268636`*^9}, 3.9459307307830296`*^9},
 CellLabel->"Out[46]=",ExpressionUUID->"8be1d54c-62bb-4cd0-a9e0-3ddd03d5e433"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Integrate", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"r", "^", "4"}], " ", 
      RowBox[{"\[Rho]0", "[", "r", "]"}]}], "/.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"i", "->", "0"}], ",", 
       RowBox[{"k", "->", "0"}]}], "}"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"r", ",", "0", ",", "Infinity"}], "}"}], ",", 
    RowBox[{"Assumptions", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"b", ">", "0"}], "}"}]}]}], "]"}], "*", "4", 
  RowBox[{"Pi", "/", 
   RowBox[{"(", 
    RowBox[{"2", "*", 
     RowBox[{"Pi", "^", "2"}]}], ")"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Integrate", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"r", "^", "4"}], " ", 
      RowBox[{"\[Rho]0", "[", "r", "]"}]}], "/.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"i", "->", "1"}], ",", 
       RowBox[{"k", "->", "0"}]}], "}"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"r", ",", "0", ",", "Infinity"}], "}"}], ",", 
    RowBox[{"Assumptions", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"b", ">", "0"}], "}"}]}]}], "]"}], "*", "4", 
  RowBox[{"Pi", "/", 
   RowBox[{"(", 
    RowBox[{"2", "*", 
     RowBox[{"Pi", "^", "2"}]}], ")"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Integrate", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"r", "^", "4"}], " ", 
      RowBox[{"\[Rho]0", "[", "r", "]"}]}], "/.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"i", "->", "2"}], ",", 
       RowBox[{"k", "->", "0"}]}], "}"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"r", ",", "0", ",", "Infinity"}], "}"}], ",", 
    RowBox[{"Assumptions", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"b", ">", "0"}], "}"}]}]}], "]"}], "*", "4", 
  RowBox[{"Pi", "/", 
   RowBox[{"(", 
    RowBox[{"2", "*", 
     RowBox[{"Pi", "^", "2"}]}], ")"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Integrate", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"r", "^", "4"}], " ", 
      RowBox[{"\[Rho]0", "[", "r", "]"}]}], "/.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"i", "->", "0"}], ",", 
       RowBox[{"k", "->", "2"}]}], "}"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"r", ",", "0", ",", "Infinity"}], "}"}], ",", 
    RowBox[{"Assumptions", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"b", ">", "0"}], "}"}]}]}], "]"}], "*", "4", 
  RowBox[{"Pi", "/", 
   RowBox[{"(", 
    RowBox[{"2", "*", 
     RowBox[{"Pi", "^", "2"}]}], ")"}]}]}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.9459302056308126`*^9, 3.9459302328192787`*^9}, {
  3.945930275548902*^9, 3.9459302920188637`*^9}, {3.9459303914645586`*^9, 
  3.945930398438776*^9}, {3.9459304402509737`*^9, 3.945930459764327*^9}, {
  3.945930693093198*^9, 3.9459307254498453`*^9}},
 CellLabel->"In[47]:=",ExpressionUUID->"fe7bfc4a-60ae-483b-8e8d-21beb8ba03fc"],

Cell[BoxData[
 FractionBox[
  RowBox[{"3", " ", 
   SuperscriptBox["b", "2"], " ", "ci"}], "2"]], "Output",
 CellChangeTimes->{3.9459303077576256`*^9, 3.9459304942660604`*^9, 
  3.945930701592886*^9, 3.9459307348215437`*^9},
 CellLabel->"Out[47]=",ExpressionUUID->"2dff4f0e-cd92-4fae-b770-83149652070a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "3"}], " ", 
  SuperscriptBox["b", "2"], " ", "ci"}]], "Output",
 CellChangeTimes->{3.9459303077576256`*^9, 3.9459304942660604`*^9, 
  3.945930701592886*^9, 3.9459307388866496`*^9},
 CellLabel->"Out[48]=",ExpressionUUID->"e05353e7-8b28-4b5e-8f65-6fe3a304ff10"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.9459303077576256`*^9, 3.9459304942660604`*^9, 
  3.945930701592886*^9, 3.9459307430375643`*^9},
 CellLabel->"Out[49]=",ExpressionUUID->"35a7129f-e2ef-440e-b990-4adfdfdb8237"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "6"}], " ", "ci"}]], "Output",
 CellChangeTimes->{3.9459303077576256`*^9, 3.9459304942660604`*^9, 
  3.945930701592886*^9, 3.9459307470580864`*^9},
 CellLabel->"Out[50]=",ExpressionUUID->"e64c6a29-1e0b-462b-9373-ae1a1d598669"]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.9459299093492503`*^9, 
  3.9459299322214007`*^9}},ExpressionUUID->"e8fb1d17-a1b4-47bf-b088-\
8c70c80e11d9"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"El0", "[", "r_", "]"}], ":=", 
  RowBox[{
   RowBox[{"1", "/", 
    RowBox[{"r", "^", "2"}]}], " ", 
   RowBox[{"Integrate", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"x", "^", "2"}], 
      RowBox[{"\[Rho]0", "[", "x", "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", "r"}], "}"}], ",", 
     RowBox[{"Assumptions", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"r", ">=", "0"}], ",", 
        RowBox[{"b", ">", "0"}], ",", 
        RowBox[{"i", ">=", "0"}]}], "}"}]}]}], 
    "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ElL", "[", "r_", "]"}], ":=", 
  RowBox[{
   RowBox[{"1", "/", 
    RowBox[{"r", "^", "2"}]}], " ", 
   RowBox[{"Integrate", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"x", "^", "2"}], 
      RowBox[{"\[Rho]L", "[", "x", "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", "r"}], "}"}], ",", 
     RowBox[{"Assumptions", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"L", ">=", "0"}], ",", 
        RowBox[{"r", ">=", "0"}], ",", 
        RowBox[{"b", ">", "0"}], ",", 
        RowBox[{"i", ">=", "0"}]}], "}"}]}]}], "]"}]}]}]}], "Input",
 CellChangeTimes->{{3.9458600205564156`*^9, 3.9458600832192607`*^9}, {
  3.945860448523043*^9, 3.9458604533278522`*^9}, {3.9458610231554384`*^9, 
  3.9458610248336368`*^9}},
 CellLabel->"In[9]:=",ExpressionUUID->"1bbcce9b-c9e7-47e4-8122-05d984750966"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"El0", "[", "r", "]"}]], "Input",
 CellLabel->"In[11]:=",ExpressionUUID->"1d67d587-3d9f-43b7-9056-da8756d1d236"],

Cell[BoxData[
 FractionBox[
  TagBox[GridBox[{
     {"\[Piecewise]", GridBox[{
        {
         RowBox[{
          FractionBox["1", "3"], " ", 
          SuperscriptBox["2", 
           RowBox[{"2", "+", "i", "+", "k"}]], " ", 
          SuperscriptBox["b", 
           RowBox[{
            RowBox[{"-", "3"}], "-", "k"}]], " ", "ci", " ", 
          SuperscriptBox["r", "3"], " ", 
          RowBox[{"Gamma", "[", 
           RowBox[{
            FractionBox["3", "2"], "+", "i", "+", 
            FractionBox["k", "2"]}], "]"}], " ", 
          RowBox[{"Hypergeometric1F1", "[", 
           RowBox[{
            RowBox[{
             FractionBox["3", "2"], "+", "i", "+", 
             FractionBox["k", "2"]}], ",", 
            FractionBox["5", "2"], ",", 
            RowBox[{"-", 
             FractionBox[
              SuperscriptBox["r", "2"], 
              SuperscriptBox["b", "2"]]}]}], "]"}]}], 
         RowBox[{"r", ">", "0"}]},
        {"0", 
         TagBox["True",
          "PiecewiseDefault",
          AutoDelete->True]}
       },
       AllowedDimensions->{2, Automatic},
       Editable->True,
       GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{1.}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.84]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}},
       Selectable->True]}
    },
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}},
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{1.}}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.35]}, 
        Offset[0.27999999999999997`]}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}}],
   "Piecewise",
   DeleteWithContents->True,
   Editable->False,
   SelectWithContents->True,
   Selectable->False,
   StripWrapperBoxes->True], 
  SuperscriptBox["r", "2"]]], "Output",
 CellChangeTimes->{{3.945860436957975*^9, 3.9458604613077087`*^9}, 
   3.945860945427951*^9, 3.9458610317268596`*^9, 3.9459298781648035`*^9},
 CellLabel->"Out[11]=",ExpressionUUID->"daa6a0c0-f78c-407e-b326-5a28b5963129"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ElL", "[", "r", "]"}]], "Input",
 CellChangeTimes->{{3.9458608065314093`*^9, 3.945860816475191*^9}, {
  3.9458609290569143`*^9, 3.9458609318049407`*^9}},
 CellLabel->"In[12]:=",ExpressionUUID->"ba2c851b-44c4-4b44-9f1b-61ea2b7cce5e"],

Cell[BoxData[
 FractionBox[
  TagBox[GridBox[{
     {"\[Piecewise]", GridBox[{
        {
         RowBox[{
          SuperscriptBox["2", 
           RowBox[{"i", "+", "k"}]], " ", 
          SuperscriptBox["b", 
           RowBox[{
            RowBox[{"-", "3"}], "-", "k", "-", "L"}]], " ", "ci", " ", 
          SqrtBox["\[Pi]"], " ", 
          SuperscriptBox["r", 
           RowBox[{"3", "+", "L"}]], " ", 
          RowBox[{"Gamma", "[", 
           FractionBox[
            RowBox[{"3", "+", "L"}], "2"], "]"}], " ", 
          RowBox[{"Gamma", "[", 
           RowBox[{
            FractionBox["1", "2"], " ", 
            RowBox[{"(", 
             RowBox[{"3", "+", 
              RowBox[{"2", " ", "i"}], "+", "k", "+", "L"}], ")"}]}], "]"}], 
          " ", 
          RowBox[{"HypergeometricPFQRegularized", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              FractionBox[
               RowBox[{"3", "+", "L"}], "2"], ",", 
              RowBox[{
               FractionBox["1", "2"], " ", 
               RowBox[{"(", 
                RowBox[{"3", "+", 
                 RowBox[{"2", " ", "i"}], "+", "k", "+", "L"}], ")"}]}]}], 
             "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              FractionBox[
               RowBox[{"5", "+", "L"}], "2"], ",", 
              RowBox[{
               FractionBox["3", "2"], "+", "L"}]}], "}"}], ",", 
            RowBox[{"-", 
             FractionBox[
              SuperscriptBox["r", "2"], 
              SuperscriptBox["b", "2"]]}]}], "]"}]}], 
         RowBox[{"r", ">", "0"}]},
        {"0", 
         TagBox["True",
          "PiecewiseDefault",
          AutoDelete->True]}
       },
       AllowedDimensions->{2, Automatic},
       Editable->True,
       GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{1.}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.84]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}},
       Selectable->True]}
    },
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}},
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{1.}}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.35]}, 
        Offset[0.27999999999999997`]}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}}],
   "Piecewise",
   DeleteWithContents->True,
   Editable->False,
   SelectWithContents->True,
   Selectable->False,
   StripWrapperBoxes->True], 
  SuperscriptBox["r", "2"]]], "Output",
 CellChangeTimes->{
  3.945860485222952*^9, {3.945860819777066*^9, 3.945860836127071*^9}, 
   3.945860954542378*^9, 3.9458610403911805`*^9, 3.945929886665177*^9},
 CellLabel->"Out[12]=",ExpressionUUID->"1ecd0d52-248d-45e9-971d-82c75c4b94a9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ElL", "[", "r", "]"}], "/.", 
  RowBox[{"{", 
   RowBox[{"L", "->", "0"}], "}"}]}]], "Input",
 CellChangeTimes->{{3.9458607213724833`*^9, 3.9458607253575387`*^9}},
 CellLabel->"In[13]:=",ExpressionUUID->"3af978e2-e64d-40e9-ae60-20d5baf01716"],

Cell[BoxData[
 FractionBox[
  TagBox[GridBox[{
     {"\[Piecewise]", GridBox[{
        {
         RowBox[{
          FractionBox["1", "3"], " ", 
          SuperscriptBox["2", 
           RowBox[{"2", "+", "i", "+", "k"}]], " ", 
          SuperscriptBox["b", 
           RowBox[{
            RowBox[{"-", "3"}], "-", "k"}]], " ", "ci", " ", 
          SuperscriptBox["r", "3"], " ", 
          RowBox[{"Gamma", "[", 
           RowBox[{
            FractionBox["1", "2"], " ", 
            RowBox[{"(", 
             RowBox[{"3", "+", 
              RowBox[{"2", " ", "i"}], "+", "k"}], ")"}]}], "]"}], " ", 
          RowBox[{"HypergeometricPFQ", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              FractionBox["3", "2"], "+", "i", "+", 
              FractionBox["k", "2"]}], "}"}], ",", 
            RowBox[{"{", 
             FractionBox["5", "2"], "}"}], ",", 
            RowBox[{"-", 
             FractionBox[
              SuperscriptBox["r", "2"], 
              SuperscriptBox["b", "2"]]}]}], "]"}]}], 
         RowBox[{"r", ">", "0"}]},
        {"0", 
         TagBox["True",
          "PiecewiseDefault",
          AutoDelete->True]}
       },
       AllowedDimensions->{2, Automatic},
       Editable->True,
       GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{1.}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.84]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}},
       Selectable->True]}
    },
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}},
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{1.}}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.35]}, 
        Offset[0.27999999999999997`]}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}}],
   "Piecewise",
   DeleteWithContents->True,
   Editable->False,
   SelectWithContents->True,
   Selectable->False,
   StripWrapperBoxes->True], 
  SuperscriptBox["r", "2"]]], "Output",
 CellChangeTimes->{3.9458607347628775`*^9, 3.9458609632680902`*^9, 
  3.9458610493913455`*^9, 3.94592989426573*^9},
 CellLabel->"Out[13]=",ExpressionUUID->"7e1e4364-b319-4298-81a6-e5ac80e1e2af"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"V0", "[", "r_", "]"}], ":=", 
  RowBox[{"-", 
   RowBox[{"Integrate", "[", 
    RowBox[{
     RowBox[{"El0", "[", "x", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "r", ",", "Infinity"}], "}"}], ",", 
     RowBox[{"Assumptions", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"r", ">=", "0"}], ",", 
        RowBox[{"b", ">", "0"}], ",", 
        RowBox[{"i", ">=", "0"}]}], "}"}]}]}], 
    "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"VL", "[", "r_", "]"}], ":=", 
  RowBox[{"-", 
   RowBox[{"Integrate", "[", 
    RowBox[{
     RowBox[{"ElL", "[", "x", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "r", ",", "Infinity"}], "}"}], ",", 
     RowBox[{"Assumptions", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"L", ">=", "0"}], ",", 
        RowBox[{"r", ">=", "0"}], ",", 
        RowBox[{"b", ">", "0"}], ",", 
        RowBox[{"i", ">=", "0"}]}], "}"}]}]}], "]"}]}]}]}], "Input",
 CellChangeTimes->{{3.9458606475251036`*^9, 3.9458606913259335`*^9}, {
  3.9458607288230963`*^9, 3.9458607747156096`*^9}, {3.9458609936656756`*^9, 
  3.9458610051605234`*^9}},
 CellLabel->"In[14]:=",ExpressionUUID->"d013d85d-0ab6-4ea6-9201-8c764b6fb611"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"V0", "[", "r", "]"}]], "Input",
 CellChangeTimes->{{3.9458607809464817`*^9, 3.94586079533593*^9}, {
  3.9458608950073605`*^9, 3.945860895870613*^9}},
 CellLabel->"In[16]:=",ExpressionUUID->"910dff4a-8107-4197-abea-082b658e1a93"],

Cell[BoxData[
 RowBox[{"-", 
  RowBox[{"(", 
   TagBox[GridBox[{
      {"\[Piecewise]", GridBox[{
         {
          RowBox[{
           SuperscriptBox["2", 
            RowBox[{"i", "+", "k"}]], " ", 
           SuperscriptBox["b", 
            RowBox[{
             RowBox[{"-", "1"}], "-", "k"}]], " ", "ci", " ", 
           RowBox[{"Gamma", "[", 
            RowBox[{
             FractionBox["1", "2"], "+", "i", "+", 
             FractionBox["k", "2"]}], "]"}], " ", 
           RowBox[{"Hypergeometric1F1", "[", 
            RowBox[{
             RowBox[{
              FractionBox["1", "2"], "+", "i", "+", 
              FractionBox["k", "2"]}], ",", 
             FractionBox["3", "2"], ",", 
             RowBox[{"-", 
              FractionBox[
               SuperscriptBox["r", "2"], 
               SuperscriptBox["b", "2"]]}]}], "]"}]}], 
          RowBox[{
           RowBox[{"r", "\[LessEqual]", "0"}], "||", 
           RowBox[{
            RowBox[{
             RowBox[{"2", " ", "i"}], "+", 
             RowBox[{"Re", "[", "k", "]"}]}], "\[LessEqual]", 
            RowBox[{"-", "1"}]}]}]},
         {
          FractionBox[
           RowBox[{
            SuperscriptBox["2", 
             RowBox[{"1", "+", "i", "+", "k"}]], " ", 
            SuperscriptBox["b", 
             RowBox[{
              RowBox[{"-", "1"}], "-", "k"}]], " ", "ci", " ", 
            RowBox[{"Gamma", "[", 
             RowBox[{
              FractionBox["3", "2"], "+", "i", "+", 
              FractionBox["k", "2"]}], "]"}], " ", 
            RowBox[{"Hypergeometric1F1", "[", 
             RowBox[{
              RowBox[{
               FractionBox["1", "2"], "+", "i", "+", 
               FractionBox["k", "2"]}], ",", 
              FractionBox["3", "2"], ",", 
              RowBox[{"-", 
               FractionBox[
                SuperscriptBox["r", "2"], 
                SuperscriptBox["b", "2"]]}]}], "]"}]}], 
           RowBox[{"1", "+", 
            RowBox[{"2", " ", "i"}], "+", "k"}]], 
          TagBox["True",
           "PiecewiseDefault",
           AutoDelete->True]}
        },
        AllowedDimensions->{2, Automatic},
        Editable->True,
        GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}},
        GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{1.}}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.84]}, 
            Offset[0.27999999999999997`]}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}},
        Selectable->True]}
     },
     GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}},
     GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{1.}}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.35]}, 
         Offset[0.27999999999999997`]}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}}],
    "Piecewise",
    DeleteWithContents->True,
    Editable->False,
    SelectWithContents->True,
    Selectable->False,
    StripWrapperBoxes->True], ")"}]}]], "Output",
 CellChangeTimes->{3.9458608978801584`*^9, 3.9458609634567327`*^9, 
  3.9458610071871414`*^9, 3.94586107110271*^9, 3.9459299272793508`*^9},
 CellLabel->"Out[16]=",ExpressionUUID->"39aa6211-680e-4844-a3f9-da914fb0722b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"VL", "[", "r", "]"}]], "Input",
 CellChangeTimes->{{3.9458609056028438`*^9, 3.9458609058697033`*^9}},
 CellLabel->"In[17]:=",ExpressionUUID->"e6c5cbc9-67fe-4105-b143-dc74a1b6710f"],

Cell[BoxData[
 RowBox[{"-", 
  RowBox[{"(", 
   TagBox[GridBox[{
      {"\[Piecewise]", GridBox[{
         {
          FractionBox[
           RowBox[{
            SuperscriptBox["2", 
             RowBox[{"i", "+", "k"}]], " ", 
            SuperscriptBox["b", 
             RowBox[{
              RowBox[{"-", "1"}], "-", "k"}]], " ", "ci", " ", 
            SqrtBox["\[Pi]"], " ", 
            RowBox[{"Gamma", "[", 
             RowBox[{
              FractionBox["1", "2"], "+", "i", "+", 
              FractionBox["k", "2"]}], "]"}], " ", 
            RowBox[{"Gamma", "[", 
             RowBox[{"1", "+", 
              FractionBox["L", "2"]}], "]"}]}], 
           RowBox[{"Gamma", "[", 
            FractionBox[
             RowBox[{"1", "+", "L"}], "2"], "]"}]], 
          RowBox[{"r", "\[Equal]", "0"}]},
         {
          FractionBox[
           RowBox[{
            SuperscriptBox["2", 
             RowBox[{"i", "+", "k"}]], " ", 
            SuperscriptBox["b", 
             RowBox[{
              RowBox[{"-", "3"}], "-", "k", "-", "L"}]], " ", "ci", " ", 
            SqrtBox["\[Pi]"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               SuperscriptBox["b", 
                RowBox[{"2", "+", "L"}]], " ", 
               RowBox[{"Gamma", "[", 
                RowBox[{
                 FractionBox["1", "2"], "+", "i", "+", 
                 FractionBox["k", "2"]}], "]"}], " ", 
               RowBox[{"Gamma", "[", 
                RowBox[{"1", "+", 
                 FractionBox["L", "2"]}], "]"}]}], "-", 
              RowBox[{
               SuperscriptBox["r", 
                RowBox[{"2", "+", "L"}]], " ", 
               RowBox[{"Gamma", "[", 
                RowBox[{"1", "+", 
                 FractionBox["L", "2"]}], "]"}], " ", 
               RowBox[{"Gamma", "[", 
                FractionBox[
                 RowBox[{"1", "+", "L"}], "2"], "]"}], " ", 
               RowBox[{"Gamma", "[", 
                RowBox[{
                 FractionBox["1", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"3", "+", 
                   RowBox[{"2", " ", "i"}], "+", "k", "+", "L"}], ")"}]}], 
                "]"}], " ", 
               RowBox[{"HypergeometricPFQRegularized", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   FractionBox[
                    RowBox[{"2", "+", "L"}], "2"], ",", 
                   RowBox[{
                    FractionBox["1", "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{"3", "+", 
                    RowBox[{"2", " ", "i"}], "+", "k", "+", "L"}], ")"}]}]}], 
                  "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   FractionBox[
                    RowBox[{"4", "+", "L"}], "2"], ",", 
                   RowBox[{
                    FractionBox["3", "2"], "+", "L"}]}], "}"}], ",", 
                 RowBox[{"-", 
                  FractionBox[
                   SuperscriptBox["r", "2"], 
                   SuperscriptBox["b", "2"]]}]}], "]"}]}], "+", 
              RowBox[{
               SuperscriptBox["r", 
                RowBox[{"2", "+", "L"}]], " ", 
               RowBox[{"Gamma", "[", 
                FractionBox[
                 RowBox[{"1", "+", "L"}], "2"], "]"}], " ", 
               RowBox[{"Gamma", "[", 
                FractionBox[
                 RowBox[{"3", "+", "L"}], "2"], "]"}], " ", 
               RowBox[{"Gamma", "[", 
                RowBox[{
                 FractionBox["1", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"3", "+", 
                   RowBox[{"2", " ", "i"}], "+", "k", "+", "L"}], ")"}]}], 
                "]"}], " ", 
               RowBox[{"HypergeometricPFQRegularized", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   FractionBox[
                    RowBox[{"3", "+", "L"}], "2"], ",", 
                   RowBox[{
                    FractionBox["1", "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{"3", "+", 
                    RowBox[{"2", " ", "i"}], "+", "k", "+", "L"}], ")"}]}]}], 
                  "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   FractionBox[
                    RowBox[{"5", "+", "L"}], "2"], ",", 
                   RowBox[{
                    FractionBox["3", "2"], "+", "L"}]}], "}"}], ",", 
                 RowBox[{"-", 
                  FractionBox[
                   SuperscriptBox["r", "2"], 
                   SuperscriptBox["b", "2"]]}]}], "]"}]}]}], ")"}]}], 
           RowBox[{"Gamma", "[", 
            FractionBox[
             RowBox[{"1", "+", "L"}], "2"], "]"}]], 
          TagBox["True",
           "PiecewiseDefault",
           AutoDelete->True]}
        },
        AllowedDimensions->{2, Automatic},
        Editable->True,
        GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}},
        GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{1.}}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.84]}, 
            Offset[0.27999999999999997`]}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}},
        Selectable->True]}
     },
     GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}},
     GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{1.}}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.35]}, 
         Offset[0.27999999999999997`]}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}}],
    "Piecewise",
    DeleteWithContents->True,
    Editable->False,
    SelectWithContents->True,
    Selectable->False,
    StripWrapperBoxes->True], ")"}]}]], "Output",
 CellChangeTimes->{3.9458609635742617`*^9, 3.945861008427066*^9, 
  3.9458610999686117`*^9, 3.9459299575554056`*^9},
 CellLabel->"Out[17]=",ExpressionUUID->"9b6dfa04-c92c-4449-9d8f-4599ce91fc97"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", 
  RowBox[{
   RowBox[{"VL", "[", "r", "]"}], "/.", 
   RowBox[{"{", 
    RowBox[{"L", "->", "0"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.945861037196374*^9, 3.94586104023989*^9}, {
  3.9458611709001093`*^9, 3.94586117393027*^9}},
 CellLabel->"In[18]:=",ExpressionUUID->"7dab3816-597c-4100-9f05-9414ad8b36eb"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   SuperscriptBox["2", 
    RowBox[{"i", "+", "k"}]]}], " ", 
  SuperscriptBox["b", 
   RowBox[{
    RowBox[{"-", "1"}], "-", "k"}]], " ", "ci", " ", 
  RowBox[{"Gamma", "[", 
   RowBox[{
    FractionBox["1", "2"], "+", "i", "+", 
    FractionBox["k", "2"]}], "]"}], " ", 
  RowBox[{"Hypergeometric1F1", "[", 
   RowBox[{
    RowBox[{
     FractionBox["1", "2"], "+", "i", "+", 
     FractionBox["k", "2"]}], ",", 
    FractionBox["3", "2"], ",", 
    RowBox[{"-", 
     FractionBox[
      SuperscriptBox["r", "2"], 
      SuperscriptBox["b", "2"]]}]}], "]"}]}]], "Output",
 CellChangeTimes->{3.9458611182301936`*^9, 3.9458612051359386`*^9, 
  3.9459299823130937`*^9},
 CellLabel->"Out[18]=",ExpressionUUID->"ed9d9f57-6b1b-44be-a12e-8c5670e5ca65"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{"FullSimplify", "[", 
   RowBox[{
    RowBox[{"Hypergeometric1F1", "[", 
     RowBox[{
      RowBox[{
       FractionBox["3", "2"], "+", "i", "+", 
       FractionBox["L", "2"]}], ",", 
      RowBox[{
       FractionBox["3", "2"], "+", "L"}], ",", 
      RowBox[{"-", 
       FractionBox[
        SuperscriptBox["r", "2"], 
        SuperscriptBox["b", "2"]]}]}], "]"}], "/", 
    RowBox[{"Gamma", "[", 
     RowBox[{
      FractionBox["3", "2"], "+", "L"}], "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.9458544631647825`*^9, 3.9458544926103277`*^9}},
 CellLabel->"In[25]:=",ExpressionUUID->"4903c200-d7da-450b-98b4-747c6ccd3489"],

Cell[BoxData[
 RowBox[{"Hypergeometric1F1Regularized", "[", 
  RowBox[{
   RowBox[{
    FractionBox["1", "2"], " ", 
    RowBox[{"(", 
     RowBox[{"3", "+", 
      RowBox[{"2", " ", "i"}], "+", "L"}], ")"}]}], ",", 
   RowBox[{
    FractionBox["3", "2"], "+", "L"}], ",", 
   RowBox[{"-", 
    FractionBox[
     SuperscriptBox["r", "2"], 
     SuperscriptBox["b", "2"]]}]}], "]"}]], "Output",
 CellChangeTimes->{{3.945854480436801*^9, 3.945854493240505*^9}},
 CellLabel->"Out[25]=",ExpressionUUID->"c6fa5a20-4c51-4152-b355-0d538459e4b1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Gamma", "[", 
  RowBox[{"3", "/", "2"}], "]"}]], "Input",
 CellChangeTimes->{{3.9458616151501274`*^9, 3.945861618166988*^9}},
 CellLabel->"In[76]:=",ExpressionUUID->"2df3067a-6e53-42d3-8fb1-ab129534df17"],

Cell[BoxData[
 FractionBox[
  SqrtBox["\[Pi]"], "2"]], "Output",
 CellChangeTimes->{3.9458616187470627`*^9},
 CellLabel->"Out[76]=",ExpressionUUID->"0ecc2364-d48f-484f-881b-4aab520766f6"]
}, Open  ]]
},
WindowSize->{1920, 1011.75},
WindowMargins->{{-6, Automatic}, {Automatic, -6}},
FrontEndVersion->"13.3 for Microsoft Windows (64-bit) (June 3, 2023)",
StyleDefinitions->"Default.nb",
ExpressionUUID->"ac5d2ae7-1121-483d-a88b-80f212e63ea7"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 690, 19, 69, "Input",ExpressionUUID->"ae97deab-f6c3-4f19-84d1-0d46bb11c510"],
Cell[CellGroupData[{
Cell[1273, 43, 201, 3, 28, "Input",ExpressionUUID->"1d7d5949-cd8e-4a88-850f-58ab92e1ad42"],
Cell[1477, 48, 529, 16, 42, "Output",ExpressionUUID->"c967390a-11eb-42c5-a185-c0b505a83842"]
}, Open  ]],
Cell[2021, 67, 354, 7, 48, "Input",ExpressionUUID->"a4243bd8-14a8-47a8-8da3-eb8000aa63f4"],
Cell[2378, 76, 1814, 47, 85, "Input",ExpressionUUID->"7f263f94-e539-4f81-b442-3ae70f478189"],
Cell[CellGroupData[{
Cell[4217, 127, 278, 4, 28, "Input",ExpressionUUID->"0693bd4a-912a-43fb-a9b8-a6e4f8e8af12"],
Cell[4498, 133, 1185, 29, 61, "Output",ExpressionUUID->"70e7e1e5-52fe-4d6c-9343-37a56da4751c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5720, 167, 261, 4, 28, "Input",ExpressionUUID->"405675d5-9d1c-4c22-a5fc-0ebc9ffb95a4"],
Cell[5984, 173, 1341, 36, 61, "Output",ExpressionUUID->"dfcf891c-6ec1-4778-97a5-27cc271641b8"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7362, 214, 278, 6, 28, "Input",ExpressionUUID->"63708d27-17a5-41d1-a2e3-0fc19b3be1c2"],
Cell[7643, 222, 1171, 31, 61, "Output",ExpressionUUID->"8c8e5f7e-21be-4741-93ba-927ed46761df"]
}, Open  ]],
Cell[CellGroupData[{
Cell[8851, 258, 1187, 32, 78, "Input",ExpressionUUID->"3eda0f84-e6f3-4f71-81fc-7abf27ad3b3c"],
Cell[10041, 292, 220, 3, 32, "Output",ExpressionUUID->"8ebbf4bb-63ce-447a-8cf1-5fcaf088d9cd"],
Cell[10264, 297, 219, 3, 32, "Output",ExpressionUUID->"9d243875-1d97-49d8-885d-ea7a4c1e783d"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10520, 305, 861, 24, 43, "Input",ExpressionUUID->"4898badd-2f85-4541-bce1-208f536cbd73"],
Cell[11384, 331, 256, 3, 32, "Output",ExpressionUUID->"8be1d54c-62bb-4cd0-a9e0-3ddd03d5e433"]
}, Open  ]],
Cell[CellGroupData[{
Cell[11677, 339, 2834, 85, 170, "Input",ExpressionUUID->"fe7bfc4a-60ae-483b-8e8d-21beb8ba03fc"],
Cell[14514, 426, 303, 6, 50, "Output",ExpressionUUID->"2dff4f0e-cd92-4fae-b770-83149652070a"],
Cell[14820, 434, 299, 6, 32, "Output",ExpressionUUID->"e05353e7-8b28-4b5e-8f65-6fe3a304ff10"],
Cell[15122, 442, 224, 3, 32, "Output",ExpressionUUID->"35a7129f-e2ef-440e-b990-4adfdfdb8237"],
Cell[15349, 447, 265, 5, 32, "Output",ExpressionUUID->"e64c6a29-1e0b-462b-9373-ae1a1d598669"]
}, Open  ]],
Cell[15629, 455, 156, 3, 28, "Input",ExpressionUUID->"e8fb1d17-a1b4-47bf-b088-8c70c80e11d9"],
Cell[15788, 460, 1440, 42, 78, "Input",ExpressionUUID->"1bbcce9b-c9e7-47e4-8122-05d984750966"],
Cell[CellGroupData[{
Cell[17253, 506, 135, 2, 28, "Input",ExpressionUUID->"1d67d587-3d9f-43b7-9056-da8756d1d236"],
Cell[17391, 510, 2311, 64, 77, "Output",ExpressionUUID->"daa6a0c0-f78c-407e-b326-5a28b5963129"]
}, Open  ]],
Cell[CellGroupData[{
Cell[19739, 579, 256, 4, 28, "Input",ExpressionUUID->"ba2c851b-44c4-4b44-9f1b-61ea2b7cce5e"],
Cell[19998, 585, 2992, 84, 59, "Output",ExpressionUUID->"1ecd0d52-248d-45e9-971d-82c75c4b94a9"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23027, 674, 277, 6, 28, "Input",ExpressionUUID->"3af978e2-e64d-40e9-ae60-20d5baf01716"],
Cell[23307, 682, 2426, 68, 77, "Output",ExpressionUUID->"7e1e4364-b319-4298-81a6-e5ac80e1e2af"]
}, Open  ]],
Cell[25748, 753, 1241, 34, 78, "Input",ExpressionUUID->"d013d85d-0ab6-4ea6-9201-8c764b6fb611"],
Cell[CellGroupData[{
Cell[27014, 791, 252, 4, 28, "Input",ExpressionUUID->"910dff4a-8107-4197-abea-082b658e1a93"],
Cell[27269, 797, 3372, 91, 82, "Output",ExpressionUUID->"39aa6211-680e-4844-a3f9-da914fb0722b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[30678, 893, 204, 3, 28, "Input",ExpressionUUID->"e6c5cbc9-67fe-4105-b143-dc74a1b6710f"],
Cell[30885, 898, 6141, 159, 105, "Output",ExpressionUUID->"9b6dfa04-c92c-4449-9d8f-4599ce91fc97"]
}, Open  ]],
Cell[CellGroupData[{
Cell[37063, 1062, 363, 8, 43, "Input",ExpressionUUID->"7dab3816-597c-4100-9f05-9414ad8b36eb"],
Cell[37429, 1072, 787, 24, 51, "Output",ExpressionUUID->"ed9d9f57-6b1b-44be-a12e-8c5670e5ca65"]
}, Open  ]],
Cell[CellGroupData[{
Cell[38253, 1101, 673, 19, 63, "Input",ExpressionUUID->"4903c200-d7da-450b-98b4-747c6ccd3489"],
Cell[38929, 1122, 538, 15, 51, "Output",ExpressionUUID->"c6fa5a20-4c51-4152-b355-0d538459e4b1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[39504, 1142, 228, 4, 43, "Input",ExpressionUUID->"2df3067a-6e53-42d3-8fb1-ab129534df17"],
Cell[39735, 1148, 187, 4, 51, "Output",ExpressionUUID->"0ecc2364-d48f-484f-881b-4aab520766f6"]
}, Open  ]]
}
]
*)

