(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 13.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     69322,       1957]
NotebookOptionsPosition[     62243,       1837]
NotebookOutlinePosition[     62731,       1855]
CellTagsIndexPosition[     62688,       1852]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[{
 RowBox[{
  RowBox[{"\[Rho]2pF0", "[", "r_", "]"}], ":=", " ", 
  RowBox[{"1", "/", 
   RowBox[{"(", 
    RowBox[{"1", " ", "+", " ", 
     RowBox[{"Exp", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"r", "-", "c"}], ")"}], "/", "z"}], "]"}]}], 
    ")"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Rho]3pF0", "[", "r_", "]"}], ":=", " ", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"1", " ", "+", " ", 
     RowBox[{"w", " ", 
      RowBox[{
       RowBox[{"r", "^", "2"}], "/", 
       RowBox[{"c", "^", "2"}]}]}]}], ")"}], "/", 
   RowBox[{"(", 
    RowBox[{"1", " ", "+", " ", 
     RowBox[{"Exp", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"r", "-", "c"}], ")"}], "/", "z"}], "]"}]}], 
    ")"}]}]}]}], "Input",
 CellChangeTimes->{{3.945936577550149*^9, 3.9459366631343927`*^9}, {
  3.9459368675466475`*^9, 3.9459368791100583`*^9}},
 CellLabel->"In[1]:=",ExpressionUUID->"a1003ecc-e7f6-490b-84ea-e10e3ed67e80"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  SubscriptBox["\[Rho]", "02"], "=", 
  RowBox[{"4", "Pi", " ", 
   RowBox[{"Integrate", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"r", "^", "2"}], " ", 
      RowBox[{"\[Rho]2pF0", "[", "r", "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"r", ",", "0", ",", "Infinity"}], "}"}], ",", 
     RowBox[{"Assumptions", "->", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"z", ">", "0"}], ",", 
        RowBox[{"c", ">", "0"}]}], "}"}]}]}], 
    "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  SubscriptBox["\[Rho]", "03"], "=", 
  RowBox[{"4", "Pi", " ", 
   RowBox[{"Integrate", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"r", "^", "2"}], " ", 
      RowBox[{"\[Rho]3pF0", "[", "r", "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"r", ",", "0", ",", "Infinity"}], "}"}], ",", 
     RowBox[{"Assumptions", "->", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"z", ">", "0"}], ",", 
        RowBox[{"c", ">", "0"}], ",", 
        RowBox[{
         RowBox[{"-", "Infinity"}], "<", "w", "<", "Infinity"}]}], "}"}]}]}], 
    "]"}]}]}]}], "Input",
 CellChangeTimes->{{3.945936670860978*^9, 3.9459366964191213`*^9}, {
  3.9459367406954*^9, 3.9459367468274436`*^9}, {3.9459368533345146`*^9, 
  3.9459368613943768`*^9}, {3.9459368929509516`*^9, 3.945936999820982*^9}, {
  3.9459374943715887`*^9, 3.9459375002461014`*^9}, {3.9459384094868927`*^9, 
  3.94593841884875*^9}},
 CellLabel->"In[3]:=",ExpressionUUID->"d592e0f8-381d-418c-a61b-6a9ee06976ea"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "8"}], " ", "\[Pi]", " ", 
  SuperscriptBox["z", "3"], " ", 
  RowBox[{"PolyLog", "[", 
   RowBox[{"3", ",", 
    RowBox[{"-", 
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{"c", "/", "z"}]]}]}], "]"}]}]], "Output",
 CellChangeTimes->{
  3.945936700069672*^9, 3.9459367496655445`*^9, {3.9459368578661594`*^9, 
   3.945936895376937*^9}, 3.945936928682294*^9, 3.9459370004133005`*^9, 
   3.945937390233711*^9, 3.9459375079051776`*^9, 3.945938452210487*^9, 
   3.94601276412253*^9, 3.948188305570097*^9},
 CellLabel->"Out[3]=",ExpressionUUID->"f75225b1-a2c2-42ac-b6fd-d9c8c2742c03"],

Cell[BoxData[
 RowBox[{"4", " ", "\[Pi]", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"-", "2"}], " ", 
     SuperscriptBox["z", "3"], " ", 
     RowBox[{"PolyLog", "[", 
      RowBox[{"3", ",", 
       RowBox[{"-", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"c", "/", "z"}]]}]}], "]"}]}], "-", 
    FractionBox[
     RowBox[{"24", " ", "w", " ", 
      SuperscriptBox["z", "5"], " ", 
      RowBox[{"PolyLog", "[", 
       RowBox[{"5", ",", 
        RowBox[{"-", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"c", "/", "z"}]]}]}], "]"}]}], 
     SuperscriptBox["c", "2"]]}], ")"}]}]], "Output",
 CellChangeTimes->{
  3.945936700069672*^9, 3.9459367496655445`*^9, {3.9459368578661594`*^9, 
   3.945936895376937*^9}, 3.945936928682294*^9, 3.9459370004133005`*^9, 
   3.945937390233711*^9, 3.9459375079051776`*^9, 3.945938452210487*^9, 
   3.94601276412253*^9, 3.9481883066201773`*^9},
 CellLabel->"Out[4]=",ExpressionUUID->"feac5ae3-690c-43b0-92b2-fea14840978f"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"\[Rho]2pF", "[", "r_", "]"}], ":=", " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "/", 
      SubscriptBox["\[Rho]", "02"]}], ")"}], "*", 
    RowBox[{"1", "/", 
     RowBox[{"(", 
      RowBox[{"1", " ", "+", " ", 
       RowBox[{"Exp", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"r", "-", "c"}], ")"}], "/", "z"}], "]"}]}], ")"}]}]}]}], 
  " ", 
  RowBox[{"(*", " ", 
   RowBox[{"*", 
    RowBox[{"Z", " ", "?"}]}], "  ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Rho]3pF", "[", "r_", "]"}], ":=", " ", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"1", "/", 
     SubscriptBox["\[Rho]", "03"]}], ")"}], "*", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", " ", "+", " ", 
      RowBox[{"w", " ", 
       RowBox[{
        RowBox[{"r", "^", "2"}], "/", 
        RowBox[{"c", "^", "2"}]}]}]}], ")"}], "/", 
    RowBox[{"(", 
     RowBox[{"1", " ", "+", " ", 
      RowBox[{"Exp", "[", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"r", "-", "c"}], ")"}], "/", "z"}], "]"}]}], ")"}], "  ", 
    RowBox[{"(*", " ", 
     RowBox[{"*", 
      RowBox[{"Z", " ", "?"}]}], "  ", "*)"}]}]}]}]}], "Input",
 CellChangeTimes->{{3.945937428172901*^9, 3.94593746640199*^9}, {
  3.9459375342982845`*^9, 3.9459375444989557`*^9}},
 CellLabel->"In[5]:=",ExpressionUUID->"d7d9227a-cf73-4ac3-be34-8de07ba42776"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"4", " ", "Pi", " ", 
  RowBox[{"Integrate", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"r", "^", "2"}], " ", 
     RowBox[{"\[Rho]2pF", "[", "r", "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"r", ",", "0", ",", "Infinity"}], "}"}], ",", 
    RowBox[{"Assumptions", "->", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"z", ">", "0"}], ",", 
       RowBox[{"c", ">", "0"}]}], "}"}]}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"4", " ", "Pi", " ", 
  RowBox[{"Integrate", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"r", "^", "2"}], " ", 
     RowBox[{"\[Rho]3pF", "[", "r", "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"r", ",", "0", ",", "Infinity"}], "}"}], ",", 
    RowBox[{"Assumptions", "->", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"z", ">", "0"}], ",", 
       RowBox[{"c", ">", "0"}], ",", 
       RowBox[{
        RowBox[{"-", "Infinity"}], "<", "w", "<", "Infinity"}]}], "}"}]}]}], 
   "]"}]}]}], "Input",
 CellChangeTimes->{{3.945937471926319*^9, 3.9459374791221247`*^9}, {
  3.9459375113779993`*^9, 3.945937517298673*^9}, {3.9459384240513844`*^9, 
  3.9459384404758115`*^9}},
 CellLabel->"In[7]:=",ExpressionUUID->"3113c2f6-6560-4fef-beec-5ec7e3c3665d"],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{
  3.9459374794718494`*^9, {3.945937517893491*^9, 3.945937546602677*^9}, 
   3.9459384553206005`*^9, 3.946012768654748*^9, 3.948188307013522*^9},
 CellLabel->"Out[7]=",ExpressionUUID->"7d2d49f4-4f9a-407e-b040-9981f04a2aca"],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{
  3.9459374794718494`*^9, {3.945937517893491*^9, 3.945937546602677*^9}, 
   3.9459384553206005`*^9, 3.946012768654748*^9, 3.9481883073745933`*^9},
 CellLabel->"Out[8]=",ExpressionUUID->"731ee9bc-723b-45f3-9b86-4c68a4fc887c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"4", " ", "Pi", " ", 
  RowBox[{"Integrate", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"r", "^", "4"}], " ", 
     RowBox[{"\[Rho]2pF", "[", "r", "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"r", ",", "0", ",", "Infinity"}], "}"}], ",", 
    RowBox[{"Assumptions", "->", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"z", ">", "0"}], ",", 
       RowBox[{"c", ">", "0"}]}], "}"}]}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"FullSimplify", "[", 
  RowBox[{"4", " ", "Pi", " ", 
   RowBox[{"Integrate", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"r", "^", "4"}], " ", 
      RowBox[{"\[Rho]3pF", "[", "r", "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"r", ",", "0", ",", "Infinity"}], "}"}], ",", 
     RowBox[{"Assumptions", "->", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"z", ">", "0"}], ",", 
        RowBox[{"c", ">", "0"}], ",", 
        RowBox[{
         RowBox[{"-", "Infinity"}], "<", "w", "<", "Infinity"}]}], "}"}]}]}], 
    "]"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.9459375546663704`*^9, 3.945937556073392*^9}, {
  3.9459384251517076`*^9, 3.9459384372723384`*^9}, {3.9460127992745333`*^9, 
  3.946012803266587*^9}},
 CellLabel->"In[9]:=",ExpressionUUID->"a3e38566-4753-4071-a3ad-75699d9cafab"],

Cell[BoxData[
 FractionBox[
  RowBox[{"12", " ", 
   SuperscriptBox["z", "2"], " ", 
   RowBox[{"PolyLog", "[", 
    RowBox[{"5", ",", 
     RowBox[{"-", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{"c", "/", "z"}]]}]}], "]"}]}], 
  RowBox[{"PolyLog", "[", 
   RowBox[{"3", ",", 
    RowBox[{"-", 
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{"c", "/", "z"}]]}]}], "]"}]]], "Output",
 CellChangeTimes->{
  3.9459375574703436`*^9, 3.9459384568240843`*^9, {3.946012796608934*^9, 
   3.9460128042417307`*^9}, 3.9481883078781223`*^9},
 CellLabel->"Out[9]=",ExpressionUUID->"c45aa20a-42f5-4153-ab2c-56e8771e340b"],

Cell[BoxData[
 FractionBox[
  RowBox[{"12", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      SuperscriptBox["c", "2"], " ", 
      SuperscriptBox["z", "2"], " ", 
      RowBox[{"PolyLog", "[", 
       RowBox[{"5", ",", 
        RowBox[{"-", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"c", "/", "z"}]]}]}], "]"}]}], "+", 
     RowBox[{"30", " ", "w", " ", 
      SuperscriptBox["z", "4"], " ", 
      RowBox[{"PolyLog", "[", 
       RowBox[{"7", ",", 
        RowBox[{"-", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"c", "/", "z"}]]}]}], "]"}]}]}], ")"}]}], 
  RowBox[{
   RowBox[{
    SuperscriptBox["c", "2"], " ", 
    RowBox[{"PolyLog", "[", 
     RowBox[{"3", ",", 
      RowBox[{"-", 
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{"c", "/", "z"}]]}]}], "]"}]}], "+", 
   RowBox[{"12", " ", "w", " ", 
    SuperscriptBox["z", "2"], " ", 
    RowBox[{"PolyLog", "[", 
     RowBox[{"5", ",", 
      RowBox[{"-", 
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{"c", "/", "z"}]]}]}], "]"}]}]}]]], "Output",
 CellChangeTimes->{
  3.9459375574703436`*^9, 3.9459384568240843`*^9, {3.946012796608934*^9, 
   3.9460128042417307`*^9}, 3.9481883082856164`*^9},
 CellLabel->"Out[10]=",ExpressionUUID->"c9fdb9e4-0335-4def-b1c6-b7304d296b36"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"F2pF", "[", "q_", "]"}], ":=", 
  RowBox[{"4", "Pi", "*", 
   RowBox[{"Integrate", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"r", "^", "2"}], " ", 
      RowBox[{"SphericalBesselJ", "[", 
       RowBox[{"0", ",", 
        RowBox[{"r", " ", "q"}]}], "]"}], " ", 
      RowBox[{"\[Rho]2pF", "[", "r", "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"r", ",", "0", ",", "Infinity"}], "}"}], ",", 
     RowBox[{"Assumptions", "->", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"z", ">", "0"}], ",", 
        RowBox[{"c", ">", "0"}], ",", 
        RowBox[{"q", ">=", "0"}]}], "}"}]}]}], 
    "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"F3pF", "[", "q_", "]"}], ":=", 
  RowBox[{"4", "Pi", "*", 
   RowBox[{"Integrate", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"r", "^", "2"}], " ", 
      RowBox[{"SphericalBesselJ", "[", 
       RowBox[{"0", ",", 
        RowBox[{"r", " ", "q"}]}], "]"}], " ", 
      RowBox[{"\[Rho]3pF", "[", "r", "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"r", ",", "0", ",", "Infinity"}], "}"}], ",", 
     RowBox[{"Assumptions", "->", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"z", ">", "0"}], ",", 
        RowBox[{"c", ">", "0"}], ",", 
        RowBox[{
         RowBox[{"-", "Infinity"}], "<", "w", "<", "Infinity"}], ",", 
        RowBox[{"q", ">=", "0"}]}], "}"}]}]}], "]"}]}]}]}], "Input",
 CellChangeTimes->{{3.945937613818863*^9, 3.945937675523679*^9}, {
  3.945938398620165*^9, 3.9459384274773636`*^9}, {3.9459388093814416`*^9, 
  3.945938819329602*^9}, {3.946013387139572*^9, 3.9460133948844395`*^9}},
 CellLabel->"In[11]:=",ExpressionUUID->"1845f264-846e-4c77-b912-73b763eb11ad"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"F2pF", "[", "q", "]"}]], "Input",
 CellChangeTimes->{{3.9460129697062087`*^9, 3.946012969821917*^9}},
 CellLabel->"In[13]:=",ExpressionUUID->"16d96bae-097c-4420-aee6-bc39946854a8"],

Cell[BoxData[
 FractionBox[
  RowBox[{"\[ImaginaryI]", " ", 
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{"c", "/", "z"}]], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"LerchPhi", "[", 
      RowBox[{
       RowBox[{"-", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"c", "/", "z"}]]}], ",", "2", ",", 
       RowBox[{"1", "-", 
        RowBox[{"\[ImaginaryI]", " ", "q", " ", "z"}]}]}], "]"}], "-", 
     RowBox[{"LerchPhi", "[", 
      RowBox[{
       RowBox[{"-", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"c", "/", "z"}]]}], ",", "2", ",", 
       RowBox[{"1", "+", 
        RowBox[{"\[ImaginaryI]", " ", "q", " ", "z"}]}]}], "]"}]}], ")"}]}], 
  RowBox[{"4", " ", "q", " ", "z", " ", 
   RowBox[{"PolyLog", "[", 
    RowBox[{"3", ",", 
     RowBox[{"-", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{"c", "/", "z"}]]}]}], "]"}]}]]], "Output",
 CellChangeTimes->{3.9460134296402025`*^9, 3.9481883544132214`*^9},
 CellLabel->"Out[13]=",ExpressionUUID->"3ff4282d-24e7-4061-8a34-87c77e968e7d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", 
  RowBox[{"F3pF", "[", "q", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.945937693108204*^9, 3.945937697966055*^9}, {
  3.9460129556652107`*^9, 3.9460129600346155`*^9}},
 CellLabel->"In[14]:=",ExpressionUUID->"fc5995e6-e262-4a14-add7-a7fdab7425e4"],

Cell[BoxData[
 FractionBox[
  RowBox[{"\[ImaginaryI]", " ", 
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{"c", "/", "z"}]], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      SuperscriptBox["c", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"LerchPhi", "[", 
         RowBox[{
          RowBox[{"-", 
           SuperscriptBox["\[ExponentialE]", 
            RowBox[{"c", "/", "z"}]]}], ",", "2", ",", 
          RowBox[{"1", "-", 
           RowBox[{"\[ImaginaryI]", " ", "q", " ", "z"}]}]}], "]"}], "-", 
        RowBox[{"LerchPhi", "[", 
         RowBox[{
          RowBox[{"-", 
           SuperscriptBox["\[ExponentialE]", 
            RowBox[{"c", "/", "z"}]]}], ",", "2", ",", 
          RowBox[{"1", "+", 
           RowBox[{"\[ImaginaryI]", " ", "q", " ", "z"}]}]}], "]"}]}], 
       ")"}]}], "+", 
     RowBox[{"6", " ", "w", " ", 
      SuperscriptBox["z", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"LerchPhi", "[", 
         RowBox[{
          RowBox[{"-", 
           SuperscriptBox["\[ExponentialE]", 
            RowBox[{"c", "/", "z"}]]}], ",", "4", ",", 
          RowBox[{"1", "-", 
           RowBox[{"\[ImaginaryI]", " ", "q", " ", "z"}]}]}], "]"}], "-", 
        RowBox[{"LerchPhi", "[", 
         RowBox[{
          RowBox[{"-", 
           SuperscriptBox["\[ExponentialE]", 
            RowBox[{"c", "/", "z"}]]}], ",", "4", ",", 
          RowBox[{"1", "+", 
           RowBox[{"\[ImaginaryI]", " ", "q", " ", "z"}]}]}], "]"}]}], 
       ")"}]}]}], ")"}]}], 
  RowBox[{"4", " ", "q", " ", "z", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      SuperscriptBox["c", "2"], " ", 
      RowBox[{"PolyLog", "[", 
       RowBox[{"3", ",", 
        RowBox[{"-", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"c", "/", "z"}]]}]}], "]"}]}], "+", 
     RowBox[{"12", " ", "w", " ", 
      SuperscriptBox["z", "2"], " ", 
      RowBox[{"PolyLog", "[", 
       RowBox[{"5", ",", 
        RowBox[{"-", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"c", "/", "z"}]]}]}], "]"}]}]}], ")"}]}]]], "Output",
 CellChangeTimes->{3.9459376997126245`*^9, 3.9459380870961795`*^9, 
  3.945938604253255*^9, 3.9459389225745316`*^9, 3.9460130464535103`*^9, 
  3.9460134993693266`*^9, 3.9481886409732866`*^9},
 CellLabel->"Out[14]=",ExpressionUUID->"9b2e532e-932b-4ecb-a629-4fb1bcaec6ec"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"El2pF", "[", "r_", "]"}], ":=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"1", "/", 
     RowBox[{"r", "^", "2"}]}], ")"}], "*", 
   RowBox[{"Integrate", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"x", "^", "2"}], " ", 
      RowBox[{"\[Rho]2pF", "[", "x", "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", "r"}], "}"}], ",", 
     RowBox[{"Assumptions", "->", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"z", ">", "0"}], ",", 
        RowBox[{"c", ">", "0"}], ",", 
        RowBox[{"r", ">=", "0"}]}], "}"}]}]}], 
    "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"El3pF", "[", "r_", "]"}], ":=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"1", "/", 
     RowBox[{"r", "^", "2"}]}], ")"}], "*", 
   RowBox[{"Integrate", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"x", "^", "2"}], " ", 
      RowBox[{"\[Rho]3pF", "[", "x", "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", "r"}], "}"}], ",", 
     RowBox[{"Assumptions", "->", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"z", ">", "0"}], ",", 
        RowBox[{"c", ">", "0"}], ",", 
        RowBox[{
         RowBox[{"-", "Infinity"}], "<", "w", "<", "Infinity"}], ",", 
        RowBox[{"r", ">=", "0"}]}], "}"}]}]}], "]"}]}]}]}], "Input",
 CellChangeTimes->{{3.9459394900481706`*^9, 3.9459395698811665`*^9}, {
  3.945939890763775*^9, 3.9459398930851154`*^9}},
 CellLabel->"In[15]:=",ExpressionUUID->"525252bd-d4d7-4692-98f4-0244449089fe"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"El2pF", "[", "r", "]"}], "\[IndentingNewLine]", 
 RowBox[{"FullSimplify", "[", 
  RowBox[{
   RowBox[{"El3pF", "[", "r", "]"}], ",", 
   RowBox[{"Assumptions", "->", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"z", ">", "0"}], ",", 
      RowBox[{"c", ">", "0"}], ",", 
      RowBox[{
       RowBox[{"-", "Infinity"}], "<", "w", "<", "Infinity"}], ",", 
      RowBox[{"r", ">=", "0"}]}], "}"}]}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.945939576420509*^9, 3.945939582904234*^9}, {
  3.948188503940135*^9, 3.948188518823918*^9}},
 CellLabel->"In[19]:=",ExpressionUUID->"e606c274-438c-48d3-ac0a-c1797c423847"],

Cell[BoxData[
 RowBox[{"-", 
  FractionBox[
   RowBox[{
    RowBox[{
     RowBox[{"-", 
      SuperscriptBox["r", "2"]}], " ", 
     RowBox[{"Log", "[", 
      RowBox[{"1", "+", 
       SuperscriptBox["\[ExponentialE]", 
        FractionBox[
         RowBox[{"c", "-", "r"}], "z"]]}], "]"}]}], "+", 
    RowBox[{"2", " ", "z", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"r", " ", 
        RowBox[{"PolyLog", "[", 
         RowBox[{"2", ",", 
          RowBox[{"-", 
           SuperscriptBox["\[ExponentialE]", 
            FractionBox[
             RowBox[{"c", "-", "r"}], "z"]]}]}], "]"}]}], "+", 
       RowBox[{"z", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           RowBox[{"PolyLog", "[", 
            RowBox[{"3", ",", 
             RowBox[{"-", 
              SuperscriptBox["\[ExponentialE]", 
               RowBox[{"c", "/", "z"}]]}]}], "]"}]}], "+", 
          RowBox[{"PolyLog", "[", 
           RowBox[{"3", ",", 
            RowBox[{"-", 
             SuperscriptBox["\[ExponentialE]", 
              FractionBox[
               RowBox[{"c", "-", "r"}], "z"]]}]}], "]"}]}], ")"}]}]}], 
      ")"}]}]}], 
   RowBox[{"8", " ", "\[Pi]", " ", 
    SuperscriptBox["r", "2"], " ", 
    SuperscriptBox["z", "2"], " ", 
    RowBox[{"PolyLog", "[", 
     RowBox[{"3", ",", 
      RowBox[{"-", 
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{"c", "/", "z"}]]}]}], "]"}]}]]}]], "Output",
 CellChangeTimes->{
  3.945939604876438*^9, {3.9481886445184164`*^9, 3.9481886678897734`*^9}},
 CellLabel->"Out[19]=",ExpressionUUID->"e24ebe5f-c9ae-4c4c-b563-1f3068552ed8"],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{
    SuperscriptBox["r", "2"], " ", 
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox["c", "2"], "+", 
      RowBox[{
       SuperscriptBox["r", "2"], " ", "w"}]}], ")"}], " ", 
    RowBox[{"Log", "[", 
     RowBox[{"1", "+", 
      SuperscriptBox["\[ExponentialE]", 
       FractionBox[
        RowBox[{"c", "-", "r"}], "z"]]}], "]"}]}], "-", 
   RowBox[{"2", " ", "r", " ", 
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox["c", "2"], "+", 
      RowBox[{"2", " ", 
       SuperscriptBox["r", "2"], " ", "w"}]}], ")"}], " ", "z", " ", 
    RowBox[{"PolyLog", "[", 
     RowBox[{"2", ",", 
      RowBox[{"-", 
       SuperscriptBox["\[ExponentialE]", 
        FractionBox[
         RowBox[{"c", "-", "r"}], "z"]]}]}], "]"}]}], "+", 
   RowBox[{"2", " ", 
    SuperscriptBox["z", "2"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       SuperscriptBox["c", "2"], " ", 
       RowBox[{"PolyLog", "[", 
        RowBox[{"3", ",", 
         RowBox[{"-", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"c", "/", "z"}]]}]}], "]"}]}], "-", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["c", "2"], "+", 
         RowBox[{"6", " ", 
          SuperscriptBox["r", "2"], " ", "w"}]}], ")"}], " ", 
       RowBox[{"PolyLog", "[", 
        RowBox[{"3", ",", 
         RowBox[{"-", 
          SuperscriptBox["\[ExponentialE]", 
           FractionBox[
            RowBox[{"c", "-", "r"}], "z"]]}]}], "]"}]}], "-", 
      RowBox[{"12", " ", "w", " ", "z", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"r", " ", 
          RowBox[{"PolyLog", "[", 
           RowBox[{"4", ",", 
            RowBox[{"-", 
             SuperscriptBox["\[ExponentialE]", 
              FractionBox[
               RowBox[{"c", "-", "r"}], "z"]]}]}], "]"}]}], "-", 
         RowBox[{"z", " ", 
          RowBox[{"PolyLog", "[", 
           RowBox[{"5", ",", 
            RowBox[{"-", 
             SuperscriptBox["\[ExponentialE]", 
              RowBox[{"c", "/", "z"}]]}]}], "]"}]}], "+", 
         RowBox[{"z", " ", 
          RowBox[{"PolyLog", "[", 
           RowBox[{"5", ",", 
            RowBox[{"-", 
             SuperscriptBox["\[ExponentialE]", 
              FractionBox[
               RowBox[{"c", "-", "r"}], "z"]]}]}], "]"}]}]}], ")"}]}]}], 
     ")"}]}]}], 
  RowBox[{"8", " ", "\[Pi]", " ", 
   SuperscriptBox["r", "2"], " ", 
   SuperscriptBox["z", "2"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      SuperscriptBox["c", "2"], " ", 
      RowBox[{"PolyLog", "[", 
       RowBox[{"3", ",", 
        RowBox[{"-", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"c", "/", "z"}]]}]}], "]"}]}], "+", 
     RowBox[{"12", " ", "w", " ", 
      SuperscriptBox["z", "2"], " ", 
      RowBox[{"PolyLog", "[", 
       RowBox[{"5", ",", 
        RowBox[{"-", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"c", "/", "z"}]]}]}], "]"}]}]}], ")"}]}]]], "Output",
 CellChangeTimes->{3.945939604876438*^9, 3.9481886445184164`*^9, 
  3.948188680657403*^9},
 CellLabel->"Out[20]=",ExpressionUUID->"9d4512ce-6a8e-4f2b-a232-a6e0ce12b676"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"El3pF", "[", "r", "]"}], "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.9481894677506666`*^9, 3.9481894714096775`*^9}},
 CellLabel->"In[28]:=",ExpressionUUID->"555d6dec-655c-4ec9-9040-fe50d0432146"],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{
    SuperscriptBox["c", "2"], " ", 
    SuperscriptBox["r", "2"], " ", 
    RowBox[{"Log", "[", 
     RowBox[{"1", "+", 
      SuperscriptBox["\[ExponentialE]", 
       FractionBox[
        RowBox[{"c", "-", "r"}], "z"]]}], "]"}]}], "+", 
   RowBox[{
    SuperscriptBox["r", "4"], " ", "w", " ", 
    RowBox[{"Log", "[", 
     RowBox[{"1", "+", 
      SuperscriptBox["\[ExponentialE]", 
       FractionBox[
        RowBox[{"c", "-", "r"}], "z"]]}], "]"}]}], "-", 
   RowBox[{"2", " ", "r", " ", 
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox["c", "2"], "+", 
      RowBox[{"2", " ", 
       SuperscriptBox["r", "2"], " ", "w"}]}], ")"}], " ", "z", " ", 
    RowBox[{"PolyLog", "[", 
     RowBox[{"2", ",", 
      RowBox[{"-", 
       SuperscriptBox["\[ExponentialE]", 
        FractionBox[
         RowBox[{"c", "-", "r"}], "z"]]}]}], "]"}]}], "+", 
   RowBox[{"2", " ", 
    SuperscriptBox["c", "2"], " ", 
    SuperscriptBox["z", "2"], " ", 
    RowBox[{"PolyLog", "[", 
     RowBox[{"3", ",", 
      RowBox[{"-", 
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{"c", "/", "z"}]]}]}], "]"}]}], "-", 
   RowBox[{"2", " ", 
    SuperscriptBox["c", "2"], " ", 
    SuperscriptBox["z", "2"], " ", 
    RowBox[{"PolyLog", "[", 
     RowBox[{"3", ",", 
      RowBox[{"-", 
       SuperscriptBox["\[ExponentialE]", 
        FractionBox[
         RowBox[{"c", "-", "r"}], "z"]]}]}], "]"}]}], "-", 
   RowBox[{"12", " ", 
    SuperscriptBox["r", "2"], " ", "w", " ", 
    SuperscriptBox["z", "2"], " ", 
    RowBox[{"PolyLog", "[", 
     RowBox[{"3", ",", 
      RowBox[{"-", 
       SuperscriptBox["\[ExponentialE]", 
        FractionBox[
         RowBox[{"c", "-", "r"}], "z"]]}]}], "]"}]}], "-", 
   RowBox[{"24", " ", "r", " ", "w", " ", 
    SuperscriptBox["z", "3"], " ", 
    RowBox[{"PolyLog", "[", 
     RowBox[{"4", ",", 
      RowBox[{"-", 
       SuperscriptBox["\[ExponentialE]", 
        FractionBox[
         RowBox[{"c", "-", "r"}], "z"]]}]}], "]"}]}], "+", 
   RowBox[{"24", " ", "w", " ", 
    SuperscriptBox["z", "4"], " ", 
    RowBox[{"PolyLog", "[", 
     RowBox[{"5", ",", 
      RowBox[{"-", 
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{"c", "/", "z"}]]}]}], "]"}]}], "-", 
   RowBox[{"24", " ", "w", " ", 
    SuperscriptBox["z", "4"], " ", 
    RowBox[{"PolyLog", "[", 
     RowBox[{"5", ",", 
      RowBox[{"-", 
       SuperscriptBox["\[ExponentialE]", 
        FractionBox[
         RowBox[{"c", "-", "r"}], "z"]]}]}], "]"}]}]}], 
  RowBox[{"8", " ", "\[Pi]", " ", 
   SuperscriptBox["r", "2"], " ", 
   SuperscriptBox["z", "2"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      SuperscriptBox["c", "2"], " ", 
      RowBox[{"PolyLog", "[", 
       RowBox[{"3", ",", 
        RowBox[{"-", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"c", "/", "z"}]]}]}], "]"}]}], "+", 
     RowBox[{"12", " ", "w", " ", 
      SuperscriptBox["z", "2"], " ", 
      RowBox[{"PolyLog", "[", 
       RowBox[{"5", ",", 
        RowBox[{"-", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"c", "/", "z"}]]}]}], "]"}]}]}], ")"}]}]]], "Output",
 CellChangeTimes->{3.9481894829507723`*^9},
 CellLabel->"Out[28]=",ExpressionUUID->"6eff2c8d-8799-46e5-a585-18007d035ca9"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"El3pF0", "[", "r_", "]"}], ":=", 
   FractionBox[
    RowBox[{
     RowBox[{
      SuperscriptBox["r", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["c", "2"], "+", 
        RowBox[{
         SuperscriptBox["r", "2"], " ", "w"}]}], ")"}], " ", 
      RowBox[{"Log", "[", 
       RowBox[{"1", "+", 
        SuperscriptBox["\[ExponentialE]", 
         FractionBox[
          RowBox[{"c", "-", "r"}], "z"]]}], "]"}]}], "-", 
     RowBox[{"2", " ", "r", " ", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["c", "2"], "+", 
        RowBox[{"2", " ", 
         SuperscriptBox["r", "2"], " ", "w"}]}], ")"}], " ", "z", " ", 
      RowBox[{"PolyLog", "[", 
       RowBox[{"2", ",", 
        RowBox[{"-", 
         SuperscriptBox["\[ExponentialE]", 
          FractionBox[
           RowBox[{"c", "-", "r"}], "z"]]}]}], "]"}]}], "+", 
     RowBox[{"2", " ", 
      SuperscriptBox["z", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         SuperscriptBox["c", "2"], " ", 
         RowBox[{"PolyLog", "[", 
          RowBox[{"3", ",", 
           RowBox[{"-", 
            SuperscriptBox["\[ExponentialE]", 
             RowBox[{"c", "/", "z"}]]}]}], "]"}]}], "-", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           SuperscriptBox["c", "2"], "+", 
           RowBox[{"6", " ", 
            SuperscriptBox["r", "2"], " ", "w"}]}], ")"}], " ", 
         RowBox[{"PolyLog", "[", 
          RowBox[{"3", ",", 
           RowBox[{"-", 
            SuperscriptBox["\[ExponentialE]", 
             FractionBox[
              RowBox[{"c", "-", "r"}], "z"]]}]}], "]"}]}], "-", 
        RowBox[{"12", " ", "w", " ", "z", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"r", " ", 
            RowBox[{"PolyLog", "[", 
             RowBox[{"4", ",", 
              RowBox[{"-", 
               SuperscriptBox["\[ExponentialE]", 
                FractionBox[
                 RowBox[{"c", "-", "r"}], "z"]]}]}], "]"}]}], "-", 
           RowBox[{"z", " ", 
            RowBox[{"PolyLog", "[", 
             RowBox[{"5", ",", 
              RowBox[{"-", 
               SuperscriptBox["\[ExponentialE]", 
                RowBox[{"c", "/", "z"}]]}]}], "]"}]}], "+", 
           RowBox[{"z", " ", 
            RowBox[{"PolyLog", "[", 
             RowBox[{"5", ",", 
              RowBox[{"-", 
               SuperscriptBox["\[ExponentialE]", 
                FractionBox[
                 RowBox[{"c", "-", "r"}], "z"]]}]}], "]"}]}]}], ")"}]}]}], 
       ")"}]}]}], 
    RowBox[{"8", " ", "\[Pi]", " ", 
     SuperscriptBox["r", "2"], " ", 
     SuperscriptBox["z", "2"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        SuperscriptBox["c", "2"], " ", 
        RowBox[{"PolyLog", "[", 
         RowBox[{"3", ",", 
          RowBox[{"-", 
           SuperscriptBox["\[ExponentialE]", 
            RowBox[{"c", "/", "z"}]]}]}], "]"}]}], "+", 
       RowBox[{"12", " ", "w", " ", 
        SuperscriptBox["z", "2"], " ", 
        RowBox[{"PolyLog", "[", 
         RowBox[{"5", ",", 
          RowBox[{"-", 
           SuperscriptBox["\[ExponentialE]", 
            RowBox[{"c", "/", "z"}]]}]}], "]"}]}]}], ")"}]}]]}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.9481894808470235`*^9, 3.948189517168396*^9}},
 CellLabel->"In[33]:=",ExpressionUUID->"85c9ca20-2517-4fb8-a0b7-64c01f2973ca"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"V2pF", "[", "r_", "]"}], ":=", 
  RowBox[{"-", 
   RowBox[{"Integrate", "[", 
    RowBox[{
     RowBox[{"El2pF", "[", "x", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "r", ",", "Infinity"}], "}"}], ",", 
     RowBox[{"Assumptions", "->", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"z", ">", "0"}], ",", 
        RowBox[{"c", ">", "0"}], ",", 
        RowBox[{"r", ">", "0"}], ",", 
        RowBox[{"x", ">", "0"}]}], "}"}]}]}], 
    "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"V3pF", "[", "r_", "]"}], ":=", 
  RowBox[{"-", 
   RowBox[{"Integrate", "[", 
    RowBox[{
     RowBox[{"El3pF0", "[", "x", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "r", ",", "Infinity"}], "}"}], ",", 
     RowBox[{"Assumptions", "->", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"z", ">", "0"}], ",", 
        RowBox[{"c", ">", "0"}], ",", 
        RowBox[{
         RowBox[{"-", "Infinity"}], "<", "w", "<", "Infinity"}], ",", 
        RowBox[{"r", ">", "0"}], ",", 
        RowBox[{"x", ">", "0"}]}], "}"}]}]}], "]"}]}]}]}], "Input",
 CellChangeTimes->{{3.945939686973159*^9, 3.945939720568777*^9}, {
   3.94593989562855*^9, 3.945939898521803*^9}, {3.9459400116499777`*^9, 
   3.9459400131465955`*^9}, {3.9459400990701127`*^9, 
   3.9459401065408945`*^9}, {3.9481887790838633`*^9, 3.948188790069543*^9}, 
   3.9481895289245605`*^9, {3.948189929008105*^9, 
   3.9481899353761525`*^9}},ExpressionUUID->"24477ca1-c9e1-4d02-8bdd-\
0daee52dbb91"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"V3pF", "[", "r", "]"}]], "Input",
 CellChangeTimes->{3.948189543148365*^9},
 CellLabel->"In[36]:=",ExpressionUUID->"1db737c1-5b7a-4976-a946-16e8b728bc7e"],

Cell[BoxData[
 RowBox[{"-", 
  RowBox[{"Integrate", "[", 
   RowBox[{
    FractionBox[
     RowBox[{
      RowBox[{
       SuperscriptBox["x", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["c", "2"], "+", 
         RowBox[{"w", " ", 
          SuperscriptBox["x", "2"]}]}], ")"}], " ", 
       RowBox[{"Log", "[", 
        RowBox[{"1", "+", 
         SuperscriptBox["\[ExponentialE]", 
          FractionBox[
           RowBox[{"c", "-", "x"}], "z"]]}], "]"}]}], "-", 
      RowBox[{"2", " ", "x", " ", 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["c", "2"], "+", 
         RowBox[{"2", " ", "w", " ", 
          SuperscriptBox["x", "2"]}]}], ")"}], " ", "z", " ", 
       RowBox[{"PolyLog", "[", 
        RowBox[{"2", ",", 
         RowBox[{"-", 
          SuperscriptBox["\[ExponentialE]", 
           FractionBox[
            RowBox[{"c", "-", "x"}], "z"]]}]}], "]"}]}], "+", 
      RowBox[{"2", " ", 
       SuperscriptBox["z", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          SuperscriptBox["c", "2"], " ", 
          RowBox[{"PolyLog", "[", 
           RowBox[{"3", ",", 
            RowBox[{"-", 
             SuperscriptBox["\[ExponentialE]", 
              RowBox[{"c", "/", "z"}]]}]}], "]"}]}], "-", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["c", "2"], "+", 
            RowBox[{"6", " ", "w", " ", 
             SuperscriptBox["x", "2"]}]}], ")"}], " ", 
          RowBox[{"PolyLog", "[", 
           RowBox[{"3", ",", 
            RowBox[{"-", 
             SuperscriptBox["\[ExponentialE]", 
              FractionBox[
               RowBox[{"c", "-", "x"}], "z"]]}]}], "]"}]}], "-", 
         RowBox[{"12", " ", "w", " ", "z", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", " ", 
             RowBox[{"PolyLog", "[", 
              RowBox[{"4", ",", 
               RowBox[{"-", 
                SuperscriptBox["\[ExponentialE]", 
                 FractionBox[
                  RowBox[{"c", "-", "x"}], "z"]]}]}], "]"}]}], "-", 
            RowBox[{"z", " ", 
             RowBox[{"PolyLog", "[", 
              RowBox[{"5", ",", 
               RowBox[{"-", 
                SuperscriptBox["\[ExponentialE]", 
                 RowBox[{"c", "/", "z"}]]}]}], "]"}]}], "+", 
            RowBox[{"z", " ", 
             RowBox[{"PolyLog", "[", 
              RowBox[{"5", ",", 
               RowBox[{"-", 
                SuperscriptBox["\[ExponentialE]", 
                 FractionBox[
                  RowBox[{"c", "-", "x"}], "z"]]}]}], "]"}]}]}], ")"}]}]}], 
        ")"}]}]}], 
     RowBox[{"8", " ", "\[Pi]", " ", 
      SuperscriptBox["x", "2"], " ", 
      SuperscriptBox["z", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         SuperscriptBox["c", "2"], " ", 
         RowBox[{"PolyLog", "[", 
          RowBox[{"3", ",", 
           RowBox[{"-", 
            SuperscriptBox["\[ExponentialE]", 
             RowBox[{"c", "/", "z"}]]}]}], "]"}]}], "+", 
        RowBox[{"12", " ", "w", " ", 
         SuperscriptBox["z", "2"], " ", 
         RowBox[{"PolyLog", "[", 
          RowBox[{"5", ",", 
           RowBox[{"-", 
            SuperscriptBox["\[ExponentialE]", 
             RowBox[{"c", "/", "z"}]]}]}], "]"}]}]}], ")"}]}]], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", "r", ",", "\[Infinity]"}], "}"}], ",", 
    RowBox[{"Assumptions", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"z", ">", "0"}], ",", 
       RowBox[{"c", ">", "0"}], ",", 
       RowBox[{
        RowBox[{"-", "\[Infinity]"}], "<", "w", "<", "\[Infinity]"}], ",", 
       RowBox[{"r", ">", "0"}], ",", 
       RowBox[{"x", ">", "0"}]}], "}"}]}]}], "]"}]}]], "Output",
 CellChangeTimes->{3.948189576935471*^9},
 CellLabel->"Out[36]=",ExpressionUUID->"1f06983f-b174-4310-a321-d962c9f481ef"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"V2pF", "[", "r", "]"}], "\[IndentingNewLine]", 
 RowBox[{"V3pF", "[", "r", "]"}]}], "Input",
 CellChangeTimes->{{3.9459397277890415`*^9, 3.945939729161307*^9}},
 CellLabel->"In[25]:=",ExpressionUUID->"4ec2e25b-09c8-4738-a226-eb337e758b93"],

Cell[BoxData[
 RowBox[{"-", 
  RowBox[{"Integrate", "[", 
   RowBox[{
    FractionBox[
     RowBox[{
      RowBox[{
       SuperscriptBox["x", "2"], " ", 
       RowBox[{"Log", "[", 
        RowBox[{"1", "+", 
         SuperscriptBox["\[ExponentialE]", 
          FractionBox[
           RowBox[{"c", "-", "x"}], "z"]]}], "]"}]}], "-", 
      RowBox[{"2", " ", "x", " ", "z", " ", 
       RowBox[{"PolyLog", "[", 
        RowBox[{"2", ",", 
         RowBox[{"-", 
          SuperscriptBox["\[ExponentialE]", 
           FractionBox[
            RowBox[{"c", "-", "x"}], "z"]]}]}], "]"}]}], "+", 
      RowBox[{"2", " ", 
       SuperscriptBox["z", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"PolyLog", "[", 
          RowBox[{"3", ",", 
           RowBox[{"-", 
            SuperscriptBox["\[ExponentialE]", 
             RowBox[{"c", "/", "z"}]]}]}], "]"}], "-", 
         RowBox[{"PolyLog", "[", 
          RowBox[{"3", ",", 
           RowBox[{"-", 
            SuperscriptBox["\[ExponentialE]", 
             FractionBox[
              RowBox[{"c", "-", "x"}], "z"]]}]}], "]"}]}], ")"}]}]}], 
     RowBox[{"8", " ", "\[Pi]", " ", 
      SuperscriptBox["x", "2"], " ", 
      SuperscriptBox["z", "2"], " ", 
      RowBox[{"PolyLog", "[", 
       RowBox[{"3", ",", 
        RowBox[{"-", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"c", "/", "z"}]]}]}], "]"}]}]], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", "r", ",", "\[Infinity]"}], "}"}], ",", 
    RowBox[{"Assumptions", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"z", ">", "0"}], ",", 
       RowBox[{"c", ">", "0"}], ",", 
       RowBox[{"r", ">", "0"}], ",", 
       RowBox[{"x", ">", "0"}]}], "}"}]}]}], "]"}]}]], "Output",
 CellChangeTimes->{3.945939772136613*^9, 3.9459399470157814`*^9, 
  3.9459400578575926`*^9, 3.945940116285947*^9, 3.945940178360921*^9, 
  3.948188863278659*^9},
 CellLabel->"Out[25]=",ExpressionUUID->"736e7181-7787-4404-bc0d-f80aac73e386"],

Cell[BoxData[
 RowBox[{"-", 
  RowBox[{"Integrate", "[", 
   RowBox[{
    FractionBox[
     RowBox[{
      RowBox[{
       SuperscriptBox["c", "2"], " ", 
       SuperscriptBox["x", "2"], " ", 
       RowBox[{"Log", "[", 
        RowBox[{"1", "+", 
         SuperscriptBox["\[ExponentialE]", 
          FractionBox[
           RowBox[{"c", "-", "x"}], "z"]]}], "]"}]}], "+", 
      RowBox[{"w", " ", 
       SuperscriptBox["x", "4"], " ", 
       RowBox[{"Log", "[", 
        RowBox[{"1", "+", 
         SuperscriptBox["\[ExponentialE]", 
          FractionBox[
           RowBox[{"c", "-", "x"}], "z"]]}], "]"}]}], "-", 
      RowBox[{"2", " ", "x", " ", 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["c", "2"], "+", 
         RowBox[{"2", " ", "w", " ", 
          SuperscriptBox["x", "2"]}]}], ")"}], " ", "z", " ", 
       RowBox[{"PolyLog", "[", 
        RowBox[{"2", ",", 
         RowBox[{"-", 
          SuperscriptBox["\[ExponentialE]", 
           FractionBox[
            RowBox[{"c", "-", "x"}], "z"]]}]}], "]"}]}], "+", 
      RowBox[{"2", " ", 
       SuperscriptBox["c", "2"], " ", 
       SuperscriptBox["z", "2"], " ", 
       RowBox[{"PolyLog", "[", 
        RowBox[{"3", ",", 
         RowBox[{"-", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"c", "/", "z"}]]}]}], "]"}]}], "-", 
      RowBox[{"2", " ", 
       SuperscriptBox["c", "2"], " ", 
       SuperscriptBox["z", "2"], " ", 
       RowBox[{"PolyLog", "[", 
        RowBox[{"3", ",", 
         RowBox[{"-", 
          SuperscriptBox["\[ExponentialE]", 
           FractionBox[
            RowBox[{"c", "-", "x"}], "z"]]}]}], "]"}]}], "-", 
      RowBox[{"12", " ", "w", " ", 
       SuperscriptBox["x", "2"], " ", 
       SuperscriptBox["z", "2"], " ", 
       RowBox[{"PolyLog", "[", 
        RowBox[{"3", ",", 
         RowBox[{"-", 
          SuperscriptBox["\[ExponentialE]", 
           FractionBox[
            RowBox[{"c", "-", "x"}], "z"]]}]}], "]"}]}], "-", 
      RowBox[{"24", " ", "w", " ", "x", " ", 
       SuperscriptBox["z", "3"], " ", 
       RowBox[{"PolyLog", "[", 
        RowBox[{"4", ",", 
         RowBox[{"-", 
          SuperscriptBox["\[ExponentialE]", 
           FractionBox[
            RowBox[{"c", "-", "x"}], "z"]]}]}], "]"}]}], "+", 
      RowBox[{"24", " ", "w", " ", 
       SuperscriptBox["z", "4"], " ", 
       RowBox[{"PolyLog", "[", 
        RowBox[{"5", ",", 
         RowBox[{"-", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"c", "/", "z"}]]}]}], "]"}]}], "-", 
      RowBox[{"24", " ", "w", " ", 
       SuperscriptBox["z", "4"], " ", 
       RowBox[{"PolyLog", "[", 
        RowBox[{"5", ",", 
         RowBox[{"-", 
          SuperscriptBox["\[ExponentialE]", 
           FractionBox[
            RowBox[{"c", "-", "x"}], "z"]]}]}], "]"}]}]}], 
     RowBox[{"8", " ", "\[Pi]", " ", 
      SuperscriptBox["x", "2"], " ", 
      SuperscriptBox["z", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         SuperscriptBox["c", "2"], " ", 
         RowBox[{"PolyLog", "[", 
          RowBox[{"3", ",", 
           RowBox[{"-", 
            SuperscriptBox["\[ExponentialE]", 
             RowBox[{"c", "/", "z"}]]}]}], "]"}]}], "+", 
        RowBox[{"12", " ", "w", " ", 
         SuperscriptBox["z", "2"], " ", 
         RowBox[{"PolyLog", "[", 
          RowBox[{"5", ",", 
           RowBox[{"-", 
            SuperscriptBox["\[ExponentialE]", 
             RowBox[{"c", "/", "z"}]]}]}], "]"}]}]}], ")"}]}]], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", "r", ",", "\[Infinity]"}], "}"}], ",", 
    RowBox[{"Assumptions", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"z", ">", "0"}], ",", 
       RowBox[{"c", ">", "0"}], ",", 
       RowBox[{
        RowBox[{"-", "\[Infinity]"}], "<", "w", "<", "\[Infinity]"}], ",", 
       RowBox[{"r", ">", "0"}], ",", 
       RowBox[{"x", ">", "0"}]}], "}"}]}]}], "]"}]}]], "Output",
 CellChangeTimes->{3.945939772136613*^9, 3.9459399470157814`*^9, 
  3.9459400578575926`*^9, 3.945940116285947*^9, 3.945940178360921*^9, 
  3.948188934439848*^9},
 CellLabel->"Out[26]=",ExpressionUUID->"6a6d7cd3-4609-469a-a0c2-3ba514d5ca02"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"-", 
  RowBox[{"Integrate", "[", 
   RowBox[{
    RowBox[{"El3pF", "[", "x", "]"}], ",", "x", ",", 
    RowBox[{"Assumptions", "->", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"z", ">", "0"}], ",", 
       RowBox[{"c", ">", "0"}], ",", 
       RowBox[{
        RowBox[{"-", "Infinity"}], "<", "w", "<", "Infinity"}], ",", 
       RowBox[{"r", ">", "0"}], ",", 
       RowBox[{"x", ">", "0"}]}], "}"}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.948188957368842*^9, 3.948188994061166*^9}},
 CellLabel->"In[27]:=",ExpressionUUID->"531f5da7-6906-4b57-a779-1ef6c24e5c2c"],

Cell[BoxData[
 RowBox[{"-", 
  FractionBox[
   RowBox[{"Integrate", "[", 
    RowBox[{
     FractionBox[
      RowBox[{
       RowBox[{
        SuperscriptBox["c", "2"], " ", 
        SuperscriptBox["x", "2"], " ", 
        RowBox[{"Log", "[", 
         RowBox[{"1", "+", 
          SuperscriptBox["\[ExponentialE]", 
           FractionBox[
            RowBox[{"c", "-", "x"}], "z"]]}], "]"}]}], "+", 
       RowBox[{"w", " ", 
        SuperscriptBox["x", "4"], " ", 
        RowBox[{"Log", "[", 
         RowBox[{"1", "+", 
          SuperscriptBox["\[ExponentialE]", 
           FractionBox[
            RowBox[{"c", "-", "x"}], "z"]]}], "]"}]}], "-", 
       RowBox[{"2", " ", "x", " ", 
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox["c", "2"], "+", 
          RowBox[{"2", " ", "w", " ", 
           SuperscriptBox["x", "2"]}]}], ")"}], " ", "z", " ", 
        RowBox[{"PolyLog", "[", 
         RowBox[{"2", ",", 
          RowBox[{"-", 
           SuperscriptBox["\[ExponentialE]", 
            FractionBox[
             RowBox[{"c", "-", "x"}], "z"]]}]}], "]"}]}], "+", 
       RowBox[{"2", " ", 
        SuperscriptBox["c", "2"], " ", 
        SuperscriptBox["z", "2"], " ", 
        RowBox[{"PolyLog", "[", 
         RowBox[{"3", ",", 
          RowBox[{"-", 
           SuperscriptBox["\[ExponentialE]", 
            RowBox[{"c", "/", "z"}]]}]}], "]"}]}], "-", 
       RowBox[{"2", " ", 
        SuperscriptBox["c", "2"], " ", 
        SuperscriptBox["z", "2"], " ", 
        RowBox[{"PolyLog", "[", 
         RowBox[{"3", ",", 
          RowBox[{"-", 
           SuperscriptBox["\[ExponentialE]", 
            FractionBox[
             RowBox[{"c", "-", "x"}], "z"]]}]}], "]"}]}], "-", 
       RowBox[{"12", " ", "w", " ", 
        SuperscriptBox["x", "2"], " ", 
        SuperscriptBox["z", "2"], " ", 
        RowBox[{"PolyLog", "[", 
         RowBox[{"3", ",", 
          RowBox[{"-", 
           SuperscriptBox["\[ExponentialE]", 
            FractionBox[
             RowBox[{"c", "-", "x"}], "z"]]}]}], "]"}]}], "-", 
       RowBox[{"24", " ", "w", " ", "x", " ", 
        SuperscriptBox["z", "3"], " ", 
        RowBox[{"PolyLog", "[", 
         RowBox[{"4", ",", 
          RowBox[{"-", 
           SuperscriptBox["\[ExponentialE]", 
            FractionBox[
             RowBox[{"c", "-", "x"}], "z"]]}]}], "]"}]}], "+", 
       RowBox[{"24", " ", "w", " ", 
        SuperscriptBox["z", "4"], " ", 
        RowBox[{"PolyLog", "[", 
         RowBox[{"5", ",", 
          RowBox[{"-", 
           SuperscriptBox["\[ExponentialE]", 
            RowBox[{"c", "/", "z"}]]}]}], "]"}]}], "-", 
       RowBox[{"24", " ", "w", " ", 
        SuperscriptBox["z", "4"], " ", 
        RowBox[{"PolyLog", "[", 
         RowBox[{"5", ",", 
          RowBox[{"-", 
           SuperscriptBox["\[ExponentialE]", 
            FractionBox[
             RowBox[{"c", "-", "x"}], "z"]]}]}], "]"}]}]}], 
      SuperscriptBox["x", "2"]], ",", "x", ",", 
     RowBox[{"Assumptions", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"z", ">", "0"}], ",", 
        RowBox[{"c", ">", "0"}], ",", 
        RowBox[{
         RowBox[{"-", "\[Infinity]"}], "<", "w", "<", "\[Infinity]"}], ",", 
        RowBox[{"r", ">", "0"}], ",", 
        RowBox[{"x", ">", "0"}]}], "}"}]}]}], "]"}], 
   RowBox[{"8", " ", "\[Pi]", " ", 
    SuperscriptBox["z", "2"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       SuperscriptBox["c", "2"], " ", 
       RowBox[{"PolyLog", "[", 
        RowBox[{"3", ",", 
         RowBox[{"-", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"c", "/", "z"}]]}]}], "]"}]}], "+", 
      RowBox[{"12", " ", "w", " ", 
       SuperscriptBox["z", "2"], " ", 
       RowBox[{"PolyLog", "[", 
        RowBox[{"5", ",", 
         RowBox[{"-", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"c", "/", "z"}]]}]}], "]"}]}]}], ")"}]}]]}]], "Output",
 CellChangeTimes->{3.9481890112560225`*^9},
 CellLabel->"Out[27]=",ExpressionUUID->"a783ad45-cec5-4525-8525-e00ca30803bc"]
}, Open  ]],

Cell[BoxData["\[IndentingNewLine]"], "Input",
 CellChangeTimes->{
  3.9460194639429197`*^9},ExpressionUUID->"6e26e864-85a9-401d-a761-\
27cb3f3034b3"],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[Rho]gauss", "[", "r_", "]"}], ":=", " ", 
  RowBox[{
   RowBox[{"Exp", "[", 
    RowBox[{"-", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"r", "/", "b"}], ")"}], "^", "2"}]}], "]"}], "/", 
   RowBox[{"(", 
    RowBox[{"Pi", " ", "*", " ", 
     RowBox[{"Sqrt", "[", "Pi", "]"}], " ", "*", " ", 
     RowBox[{"b", "^", "3"}]}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.946019477439114*^9, 3.9460195166731777`*^9}},
 CellLabel->"In[1]:=",ExpressionUUID->"70177efd-7bc5-4651-bf50-a84bf2eafe48"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"4", "*", "Pi", " ", "*", 
  RowBox[{"Integrate", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"r", "^", "2"}], 
     RowBox[{"\[Rho]gauss", "[", "r", "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"r", ",", "0", ",", "Infinity"}], "}"}], ",", 
    RowBox[{"Assumptions", "->", 
     RowBox[{"{", 
      RowBox[{"b", ">", "0"}], "}"}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.9460195239144197`*^9, 3.946019560209091*^9}},
 CellLabel->"In[3]:=",ExpressionUUID->"28aff260-44a3-42ad-ab64-76867365c097"],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{{3.9460195440897226`*^9, 3.946019561903931*^9}},
 CellLabel->"Out[3]=",ExpressionUUID->"4d66d562-f6a5-48a3-8603-4ec299ce9576"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"4", "*", "Pi", " ", "*", 
  RowBox[{"Integrate", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"r", "^", "4"}], 
     RowBox[{"\[Rho]gauss", "[", "r", "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"r", ",", "0", ",", "Infinity"}], "}"}], ",", 
    RowBox[{"Assumptions", "->", 
     RowBox[{"{", 
      RowBox[{"b", ">", "0"}], "}"}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.946019576318963*^9, 3.9460195764555855`*^9}},
 CellLabel->"In[4]:=",ExpressionUUID->"4bc39a0d-c090-4dc1-95a0-8df524bbc013"],

Cell[BoxData[
 FractionBox[
  RowBox[{"3", " ", 
   SuperscriptBox["b", "2"]}], "2"]], "Output",
 CellChangeTimes->{3.9460195771178694`*^9},
 CellLabel->"Out[4]=",ExpressionUUID->"ab62bcce-86c7-4fd9-ba49-6b096141cfb3"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Fgauss", "[", "q_", "]"}], ":=", 
  RowBox[{"4", "*", "Pi", " ", "*", 
   RowBox[{"Integrate", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"r", "^", "2"}], " ", 
      RowBox[{"SphericalBesselJ", "[", 
       RowBox[{"0", ",", 
        RowBox[{"r", " ", "q"}]}], "]"}], " ", 
      RowBox[{"\[Rho]gauss", "[", "r", "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"r", ",", "0", ",", "Infinity"}], "}"}], ",", 
     RowBox[{"Assumptions", "->", 
      RowBox[{"{", 
       RowBox[{"b", ">", "0"}], "}"}]}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.946019656854449*^9, 3.9460196915330205`*^9}},
 CellLabel->"In[5]:=",ExpressionUUID->"d8936e6c-aaa2-4afd-9584-637bfef10f2c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Fgauss", "[", "q", "]"}]], "Input",
 CellChangeTimes->{{3.946019695037335*^9, 3.9460196974699597`*^9}},
 CellLabel->"In[6]:=",ExpressionUUID->"8cdb22db-78da-453c-9739-4a54c93be6ee"],

Cell[BoxData[
 SuperscriptBox["\[ExponentialE]", 
  RowBox[{
   RowBox[{"-", 
    FractionBox["1", "4"]}], " ", 
   SuperscriptBox["b", "2"], " ", 
   SuperscriptBox["q", "2"]}]]], "Output",
 CellChangeTimes->{3.946019722434209*^9},
 CellLabel->"Out[6]=",ExpressionUUID->"441f1072-8c9f-4547-b3e2-6a73d495dcab"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.9460296008213983`*^9, 
  3.9460296009426947`*^9}},ExpressionUUID->"21d2c84b-711e-4afa-a413-\
24f74c1a4931"],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[Rho]uni", "[", "r_", "]"}], ":=", " ", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"r", ">", "R"}], ",", "0", ",", 
    FractionBox[
     RowBox[{"3", "Z"}], 
     RowBox[{"4", "\[Pi]", " ", 
      RowBox[{"R", "^", "3"}]}]]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.946029604319086*^9, 3.946029635917326*^9}, {
  3.9460296847465124`*^9, 3.946029684902376*^9}, {3.9460297271032915`*^9, 
  3.9460297387988358`*^9}, {3.946029773131897*^9, 3.9460298053753033`*^9}},
 CellLabel->"In[12]:=",ExpressionUUID->"ad9b486e-b9d3-42df-bcfd-d5d0c72827d0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"4", "*", "Pi", "*", 
  RowBox[{"Integrate", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"r", "^", "2"}], 
     RowBox[{"\[Rho]uni", "[", "r", "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"r", ",", "0", ",", "Infinity"}], "}"}], ",", 
    RowBox[{"Assumptions", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"R", ">", "0"}], "}"}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.946029639096619*^9, 3.9460296639202056`*^9}, {
  3.9460297066372986`*^9, 3.9460297108039227`*^9}},
 CellLabel->"In[13]:=",ExpressionUUID->"ced4795f-c013-426f-b12a-bb8f7f321bac"],

Cell[BoxData["Z"], "Output",
 CellChangeTimes->{{3.946029665740995*^9, 3.9460297491099453`*^9}, {
  3.946029790109948*^9, 3.9460298069011154`*^9}},
 CellLabel->"Out[13]=",ExpressionUUID->"39621294-9097-49cb-86d3-2a2c855346ea"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"4", "*", 
  FractionBox["Pi", "Z"], "*", 
  RowBox[{"Integrate", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"r", "^", "4"}], 
     RowBox[{"\[Rho]uni", "[", "r", "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"r", ",", "0", ",", "Infinity"}], "}"}], ",", 
    RowBox[{"Assumptions", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"R", ">", "0"}], "}"}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.9460298481333933`*^9, 3.9460298548319807`*^9}},
 CellLabel->"In[15]:=",ExpressionUUID->"7a74e434-33e0-4fe5-a5cb-ad442b947481"],

Cell[BoxData[
 FractionBox[
  RowBox[{"3", " ", 
   SuperscriptBox["R", "2"]}], "5"]], "Output",
 CellChangeTimes->{{3.9460298488882976`*^9, 3.9460298554597864`*^9}},
 CellLabel->"Out[15]=",ExpressionUUID->"5e35f01e-16e0-4bce-99bd-4160eaa93104"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Funi", "[", "q_", "]"}], ":=", 
  RowBox[{"4", "*", "Pi", " ", "*", 
   RowBox[{"Integrate", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"r", "^", "2"}], " ", 
      RowBox[{"SphericalBesselJ", "[", 
       RowBox[{"0", ",", 
        RowBox[{"r", " ", "q"}]}], "]"}], " ", 
      RowBox[{"\[Rho]uni", "[", "r", "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"r", ",", "0", ",", "Infinity"}], "}"}], ",", 
     RowBox[{"Assumptions", "->", 
      RowBox[{"{", 
       RowBox[{"R", ">", "0"}], "}"}]}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.9460300775217943`*^9, 3.946030089253415*^9}},
 CellLabel->"In[16]:=",ExpressionUUID->"8aff209e-eb48-4b22-b320-df70a1fbc732"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Funi", "[", "q", "]"}]], "Input",
 CellChangeTimes->{{3.946030090794217*^9, 3.946030092898311*^9}},
 CellLabel->"In[17]:=",ExpressionUUID->"889bb1b6-eb83-4a67-8ea2-952e71604903"],

Cell[BoxData[
 RowBox[{"-", 
  FractionBox[
   RowBox[{"3", " ", "Z", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"q", " ", "R", " ", 
       RowBox[{"Cos", "[", 
        RowBox[{"q", " ", "R"}], "]"}]}], "-", 
      RowBox[{"Sin", "[", 
       RowBox[{"q", " ", "R"}], "]"}]}], ")"}]}], 
   RowBox[{
    SuperscriptBox["q", "3"], " ", 
    SuperscriptBox["R", "3"]}]]}]], "Output",
 CellChangeTimes->{3.946030098860716*^9},
 CellLabel->"Out[17]=",ExpressionUUID->"9d46efde-19c7-4a9d-8a04-0b952309c57a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", 
  RowBox[{
   RowBox[{"3", 
    FractionBox["Z", 
     RowBox[{"q", " ", "R"}]], " ", 
    RowBox[{"SphericalBesselJ", "[", 
     RowBox[{"1", ",", 
      RowBox[{"q", " ", "R"}]}], "]"}]}], "==", 
   RowBox[{"Funi", "[", "q", "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.946030127303512*^9, 3.94603013283356*^9}, {
  3.946030188758572*^9, 3.9460302278278847`*^9}},
 CellLabel->"In[21]:=",ExpressionUUID->"96f46002-67cf-4d23-a565-23d9c1b512f0"],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{
  3.946030133179254*^9, {3.946030199970953*^9, 3.94603023455815*^9}},
 CellLabel->"Out[21]=",ExpressionUUID->"769a3f56-9ab6-4391-8416-0f81c7295714"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Eluni", "[", "r_", "]"}], ":=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"1", "/", 
     RowBox[{"r", "^", "2"}]}], ")"}], "*", 
   RowBox[{"Integrate", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"x", "^", "2"}], " ", 
      RowBox[{"\[Rho]uni", "[", "x", "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", "r"}], "}"}], ",", 
     RowBox[{"Assumptions", "->", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"R", ">", "0"}], ",", 
        RowBox[{"r", ">=", "0"}]}], "}"}]}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.9460303701426053`*^9, 3.9460303867392673`*^9}, {
  3.9460304324466763`*^9, 
  3.9460304512235346`*^9}},ExpressionUUID->"30620c1a-cba9-4428-8ba9-\
a6a9e9eba208"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", 
  RowBox[{
   RowBox[{"Eluni", "[", "r", "]"}], ",", 
   RowBox[{"Assumptions", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"r", ">=", "0"}], ",", 
      RowBox[{"R", ">", "0"}]}], "}"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.9460303891411166`*^9, 3.9460303938332787`*^9}, {
  3.9460304531725645`*^9, 3.9460304662264357`*^9}},
 CellLabel->"In[26]:=",ExpressionUUID->"bbfae643-9b3c-42fc-8e81-23dfd1a9987a"],

Cell[BoxData[
 TagBox[GridBox[{
    {"\[Piecewise]", GridBox[{
       {
        FractionBox["Z", 
         RowBox[{"4", " ", "\[Pi]", " ", 
          SuperscriptBox["r", "2"]}]], 
        RowBox[{
         RowBox[{"r", "\[GreaterEqual]", "R"}], "||", 
         RowBox[{"r", "\[LessEqual]", "0"}]}]},
       {
        FractionBox[
         RowBox[{"r", " ", "Z"}], 
         RowBox[{"4", " ", "\[Pi]", " ", 
          SuperscriptBox["R", "3"]}]], 
        TagBox["True",
         "PiecewiseDefault",
         AutoDelete->True]}
      },
      AllowedDimensions->{2, Automatic},
      Editable->True,
      GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}},
      GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{1.}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.84]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}},
      Selectable->True]}
   },
   GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{1.}}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[0.35]}, 
       Offset[0.27999999999999997`]}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}}],
  "Piecewise",
  DeleteWithContents->True,
  Editable->False,
  SelectWithContents->True,
  Selectable->False,
  StripWrapperBoxes->True]], "Output",
 CellChangeTimes->{3.946030395167635*^9, 3.946030434188923*^9, 
  3.9460304672778077`*^9},
 CellLabel->"Out[26]=",ExpressionUUID->"639b3f53-eaeb-4432-a2c4-8efd47b8e87d"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Vuni", "[", "r_", "]"}], ":=", 
  RowBox[{"-", 
   RowBox[{"Integrate", "[", 
    RowBox[{
     RowBox[{"Eluni", "[", "x", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "r", ",", "Infinity"}], "}"}], ",", 
     RowBox[{"Assumptions", "->", 
      RowBox[{"{", 
       RowBox[{"R", ">", 
        RowBox[{"0", "r"}], ">=", "0"}], "}"}]}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.9460305886222277`*^9, 3.9460306095439854`*^9}},
 CellLabel->"In[27]:=",ExpressionUUID->"4a2c23cf-d308-4fd6-86aa-18a3ddbd91de"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", 
  RowBox[{
   RowBox[{"Vuni", "[", "r", "]"}], ",", 
   RowBox[{"Assumptions", "->", 
    RowBox[{"{", 
     RowBox[{"r", ">", "R", ">=", "0"}], "}"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.946030686217024*^9, 3.946030687488448*^9}},
 CellLabel->"In[32]:=",ExpressionUUID->"94f80334-4b20-419e-9f44-72a92ddfd16d"],

Cell[BoxData[
 TemplateBox[{
  "Integrate", "pwrl", 
   "\"Unable to prove that integration limits \\!\\(\\*RowBox[{\\\"{\\\", \
\\\"r\\\", \\\"}\\\"}]\\) are real. Adding assumptions may help.\"", 2, 32, 6,
    33707137775176882622, "Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.946030688923739*^9},
 CellLabel->
  "During evaluation of \
In[32]:=",ExpressionUUID->"36b53203-bfe4-4012-80ac-e105b2da06bb"],

Cell[BoxData[
 RowBox[{"-", 
  FractionBox["Z", 
   RowBox[{"4", " ", "\[Pi]", " ", "r"}]]}]], "Output",
 CellChangeTimes->{3.946030689142844*^9},
 CellLabel->"Out[32]=",ExpressionUUID->"664012d7-1c46-4dc0-ab5a-bfa64e7bfc8a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", 
  RowBox[{
   RowBox[{"Vuni", "[", "r", "]"}], ",", 
   RowBox[{"Assumptions", "->", 
    RowBox[{"{", 
     RowBox[{"R", ">", "r", ">=", "0"}], "}"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.9460306126491776`*^9, 3.946030671480813*^9}},
 CellLabel->"In[31]:=",ExpressionUUID->"f19efb70-5921-4bc7-8291-b0fe9c57ac99"],

Cell[BoxData[
 TemplateBox[{
  "Integrate", "pwrl", 
   "\"Unable to prove that integration limits \\!\\(\\*RowBox[{\\\"{\\\", \
\\\"r\\\", \\\"}\\\"}]\\) are real. Adding assumptions may help.\"", 2, 31, 5,
    33707137775176882622, "Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{{3.946030618405321*^9, 3.946030678337294*^9}},
 CellLabel->
  "During evaluation of \
In[31]:=",ExpressionUUID->"13734e88-4177-4e38-80b7-0245fa4cdae3"],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     SuperscriptBox["r", "2"], "-", 
     RowBox[{"3", " ", 
      SuperscriptBox["R", "2"]}]}], ")"}], " ", "Z"}], 
  RowBox[{"8", " ", "\[Pi]", " ", 
   SuperscriptBox["R", "3"]}]]], "Output",
 CellChangeTimes->{{3.9460306184995923`*^9, 3.946030678540803*^9}},
 CellLabel->"Out[31]=",ExpressionUUID->"605d2863-7848-42b8-8bec-0f825383f9d1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", 
  RowBox[{
   RowBox[{"Vuni", "[", "0", "]"}], ",", 
   RowBox[{"Assumptions", "->", 
    RowBox[{"{", 
     RowBox[{"R", ">", "r", ">=", "0"}], "}"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.946031114175514*^9, 3.946031117363251*^9}},
 CellLabel->"In[34]:=",ExpressionUUID->"8f48634b-d56a-42ca-bd53-9088731f99a7"],

Cell[BoxData[
 RowBox[{"-", 
  FractionBox[
   RowBox[{"3", " ", "Z"}], 
   RowBox[{"8", " ", "\[Pi]", " ", "R"}]]}]], "Output",
 CellChangeTimes->{{3.946031115713462*^9, 3.94603111836861*^9}},
 CellLabel->"Out[34]=",ExpressionUUID->"10ea19ea-10e1-4bc6-9d98-eed2b8279b0c"]
}, Open  ]]
},
WindowSize->{2293.2, 1222.2},
WindowMargins->{{Automatic, -574.1999999999998}, {
  642.6000000000001, Automatic}},
TaggingRules->Association["TryRealOnly" -> False],
FrontEndVersion->"12.3 for Microsoft Windows (64-bit) (July 9, 2021)",
StyleDefinitions->"Default.nb",
ExpressionUUID->"3b73b206-ebe4-4a83-877e-7b829d9a7be0"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 964, 29, 78, "Input",ExpressionUUID->"a1003ecc-e7f6-490b-84ea-e10e3ed67e80"],
Cell[CellGroupData[{
Cell[1547, 53, 1484, 40, 78, "Input",ExpressionUUID->"d592e0f8-381d-418c-a61b-6a9ee06976ea"],
Cell[3034, 95, 626, 14, 34, "Output",ExpressionUUID->"f75225b1-a2c2-42ac-b6fd-d9c8c2742c03"],
Cell[3663, 111, 1012, 26, 57, "Output",ExpressionUUID->"feac5ae3-690c-43b0-92b2-fea14840978f"]
}, Open  ]],
Cell[4690, 140, 1390, 43, 78, "Input",ExpressionUUID->"d7d9227a-cf73-4ac3-be34-8de07ba42776"],
Cell[CellGroupData[{
Cell[6105, 187, 1209, 33, 78, "Input",ExpressionUUID->"3113c2f6-6560-4fef-beec-5ec7e3c3665d"],
Cell[7317, 222, 271, 4, 32, "Output",ExpressionUUID->"7d2d49f4-4f9a-407e-b040-9981f04a2aca"],
Cell[7591, 228, 273, 4, 32, "Output",ExpressionUUID->"731ee9bc-723b-45f3-9b86-4c68a4fc887c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7901, 237, 1263, 34, 78, "Input",ExpressionUUID->"a3e38566-4753-4071-a3ad-75699d9cafab"],
Cell[9167, 273, 629, 17, 59, "Output",ExpressionUUID->"c45aa20a-42f5-4153-ab2c-56e8771e340b"],
Cell[9799, 292, 1302, 38, 59, "Output",ExpressionUUID->"c9fdb9e4-0335-4def-b1c6-b7304d296b36"]
}, Open  ]],
Cell[11116, 333, 1691, 45, 78, "Input",ExpressionUUID->"1845f264-846e-4c77-b912-73b763eb11ad"],
Cell[CellGroupData[{
Cell[12832, 382, 204, 3, 28, "Input",ExpressionUUID->"16d96bae-097c-4420-aee6-bc39946854a8"],
Cell[13039, 387, 1049, 28, 59, "Output",ExpressionUUID->"3ff4282d-24e7-4061-8a34-87c77e968e7d"]
}, Open  ]],
Cell[CellGroupData[{
Cell[14125, 420, 294, 5, 43, "Input",ExpressionUUID->"fc5995e6-e262-4a14-add7-a7fdab7425e4"],
Cell[14422, 427, 2372, 65, 59, "Output",ExpressionUUID->"9b2e532e-932b-4ecb-a629-4fb1bcaec6ec"]
}, Open  ]],
Cell[16809, 495, 1494, 44, 78, "Input",ExpressionUUID->"525252bd-d4d7-4692-98f4-0244449089fe"],
Cell[CellGroupData[{
Cell[18328, 543, 638, 15, 62, "Input",ExpressionUUID->"e606c274-438c-48d3-ac0a-c1797c423847"],
Cell[18969, 560, 1619, 48, 70, "Output",ExpressionUUID->"e24ebe5f-c9ae-4c4c-b563-1f3068552ed8"],
Cell[20591, 610, 3175, 95, 70, "Output",ExpressionUUID->"9d4512ce-6a8e-4f2b-a232-a6e0ce12b676"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23803, 710, 243, 4, 48, "Input",ExpressionUUID->"555d6dec-655c-4ec9-9040-fe50d0432146"],
Cell[24049, 716, 3290, 99, 67, "Output",ExpressionUUID->"6eff2c8d-8799-46e5-a585-18007d035ca9"]
}, Open  ]],
Cell[27354, 818, 3455, 98, 110, "Input",ExpressionUUID->"85c9ca20-2517-4fb8-a0b7-64c01f2973ca"],
Cell[30812, 918, 1515, 40, 78, "Input",ExpressionUUID->"24477ca1-c9e1-4d02-8bdd-0daee52dbb91"],
Cell[CellGroupData[{
Cell[32352, 962, 178, 3, 28, "Input",ExpressionUUID->"1db737c1-5b7a-4976-a946-16e8b728bc7e"],
Cell[32533, 967, 3878, 108, 70, "Output",ExpressionUUID->"1f06983f-b174-4310-a321-d962c9f481ef"]
}, Open  ]],
Cell[CellGroupData[{
Cell[36448, 1080, 264, 4, 48, "Input",ExpressionUUID->"4ec2e25b-09c8-4738-a226-eb337e758b93"],
Cell[36715, 1086, 1987, 55, 70, "Output",ExpressionUUID->"736e7181-7787-4404-bc0d-f80aac73e386"],
Cell[38705, 1143, 4175, 115, 67, "Output",ExpressionUUID->"6a6d7cd3-4609-469a-a0c2-3ba514d5ca02"]
}, Open  ]],
Cell[CellGroupData[{
Cell[42917, 1263, 600, 15, 43, "Input",ExpressionUUID->"531f5da7-6906-4b57-a779-1ef6c24e5c2c"],
Cell[43520, 1280, 4050, 112, 78, "Output",ExpressionUUID->"a783ad45-cec5-4525-8525-e00ca30803bc"]
}, Open  ]],
Cell[47585, 1395, 149, 3, 48, "Input",ExpressionUUID->"6e26e864-85a9-401d-a761-27cb3f3034b3"],
Cell[47737, 1400, 536, 14, 43, "Input",ExpressionUUID->"70177efd-7bc5-4651-bf50-a84bf2eafe48"],
Cell[CellGroupData[{
Cell[48298, 1418, 525, 13, 43, "Input",ExpressionUUID->"28aff260-44a3-42ad-ab64-76867365c097"],
Cell[48826, 1433, 174, 2, 32, "Output",ExpressionUUID->"4d66d562-f6a5-48a3-8603-4ec299ce9576"]
}, Open  ]],
Cell[CellGroupData[{
Cell[49037, 1440, 525, 13, 43, "Input",ExpressionUUID->"4bc39a0d-c090-4dc1-95a0-8df524bbc013"],
Cell[49565, 1455, 218, 5, 50, "Output",ExpressionUUID->"ab62bcce-86c7-4fd9-ba49-6b096141cfb3"]
}, Open  ]],
Cell[49798, 1463, 712, 18, 43, "Input",ExpressionUUID->"d8936e6c-aaa2-4afd-9584-637bfef10f2c"],
Cell[CellGroupData[{
Cell[50535, 1485, 205, 3, 28, "Input",ExpressionUUID->"8cdb22db-78da-453c-9739-4a54c93be6ee"],
Cell[50743, 1490, 310, 8, 39, "Output",ExpressionUUID->"441f1072-8c9f-4547-b3e2-6a73d495dcab"]
}, Open  ]],
Cell[51068, 1501, 210, 4, 67, "Input",ExpressionUUID->"21d2c84b-711e-4afa-a413-24f74c1a4931"],
Cell[51281, 1507, 583, 13, 60, "Input",ExpressionUUID->"ad9b486e-b9d3-42df-bcfd-d5d0c72827d0"],
Cell[CellGroupData[{
Cell[51889, 1524, 577, 14, 43, "Input",ExpressionUUID->"ced4795f-c013-426f-b12a-bb8f7f321bac"],
Cell[52469, 1540, 226, 3, 32, "Output",ExpressionUUID->"39621294-9097-49cb-86d3-2a2c855346ea"]
}, Open  ]],
Cell[CellGroupData[{
Cell[52732, 1548, 547, 14, 60, "Input",ExpressionUUID->"7a74e434-33e0-4fe5-a5cb-ad442b947481"],
Cell[53282, 1564, 245, 5, 50, "Output",ExpressionUUID->"5e35f01e-16e0-4bce-99bd-4160eaa93104"]
}, Open  ]],
Cell[53542, 1572, 709, 18, 43, "Input",ExpressionUUID->"8aff209e-eb48-4b22-b320-df70a1fbc732"],
Cell[CellGroupData[{
Cell[54276, 1594, 202, 3, 28, "Input",ExpressionUUID->"889bb1b6-eb83-4a67-8ea2-952e71604903"],
Cell[54481, 1599, 511, 15, 52, "Output",ExpressionUUID->"9d46efde-19c7-4a9d-8a04-0b952309c57a"]
}, Open  ]],
Cell[CellGroupData[{
Cell[55029, 1619, 492, 12, 62, "Input",ExpressionUUID->"96f46002-67cf-4d23-a565-23d9c1b512f0"],
Cell[55524, 1633, 200, 3, 32, "Output",ExpressionUUID->"769a3f56-9ab6-4391-8416-0f81c7295714"]
}, Open  ]],
Cell[55739, 1639, 743, 22, 43, "Input",ExpressionUUID->"30620c1a-cba9-4428-8ba9-a6a9e9eba208"],
Cell[CellGroupData[{
Cell[56507, 1665, 469, 11, 43, "Input",ExpressionUUID->"bbfae643-9b3c-42fc-8e81-23dfd1a9987a"],
Cell[56979, 1678, 1685, 49, 69, "Output",ExpressionUUID->"639b3f53-eaeb-4432-a2c4-8efd47b8e87d"]
}, Open  ]],
Cell[58679, 1730, 553, 14, 43, "Input",ExpressionUUID->"4a2c23cf-d308-4fd6-86aa-18a3ddbd91de"],
Cell[CellGroupData[{
Cell[59257, 1748, 362, 8, 43, "Input",ExpressionUUID->"94f80334-4b20-419e-9f44-72a92ddfd16d"],
Cell[59622, 1758, 431, 10, 28, "Message",ExpressionUUID->"36b53203-bfe4-4012-80ac-e105b2da06bb"],
Cell[60056, 1770, 225, 5, 49, "Output",ExpressionUUID->"664012d7-1c46-4dc0-ab5a-bfa64e7bfc8a"]
}, Open  ]],
Cell[CellGroupData[{
Cell[60318, 1780, 364, 8, 43, "Input",ExpressionUUID->"f19efb70-5921-4bc7-8291-b0fe9c57ac99"],
Cell[60685, 1790, 455, 10, 28, "Message",ExpressionUUID->"13734e88-4177-4e38-80b7-0245fa4cdae3"],
Cell[61143, 1802, 410, 11, 54, "Output",ExpressionUUID->"605d2863-7848-42b8-8bec-0f825383f9d1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[61590, 1818, 362, 8, 43, "Input",ExpressionUUID->"8f48634b-d56a-42ca-bd53-9088731f99a7"],
Cell[61955, 1828, 272, 6, 72, "Output",ExpressionUUID->"10ea19ea-10e1-4bc6-9d98-eed2b8279b0c"]
}, Open  ]]
}
]
*)

